#!/usr/bin/suidperl

package program;

use strict;
use lib ("/home/web-mycompany/www/lib");
use My;
use MyXML;
use MyCGI;
use Info;
use Output;
use Form;
use Authen::PAM;

#==== !!! POZOR do nastaveni globalnich promenych nesmis pouzivat fce, ktere je potrebuji
my $query=MyCGI->cgisession;
my $idcs=undef;

#==== Nastaveni globalnich promennych
set_env("datum", My->date_now);
my $state=0;

program->form;

sub form {
   # nastav promenou obsahujici popis zarizeni na ktere bude probihat vystup
   my $outputdev=My->outputdev($query);
   $$outputdev{bezpre}=1;
   # vytvoreni html dokumentu
   my ($docO,$htmlO,$bodyO)=MyXML->creahtml($outputdev,$idcs);
   if(my $why=newpassword_isnotok()) {
      if(defined($query->param("submit"))) {
         $bodyO->aT("p",{ style => "color: red;" },"Heslo nebylo mon zmnit.");
         $bodyO->aT("p",{ style => "color: red;" },$why);
      }
      else {
         $bodyO->aT("p",{},"Heslo mus mt minimln 6 a maximln 8 znak.");
      }
      Form->form_val_list(
         $bodyO,
         {
            oldpassword => { print => "Star heslo", type => "password", size => 8 },
            newpassword => { print => "Nov heslo",  type => "password", size => 8 },
            renewpassword => { print => "Znovu nov heslo", type => "password", size => 8 },
            "_layout" => [ [ { names => ["oldpassword", "newpassword", "renewpassword"] } ] ]
         },
         ["Zmnit heslo"]
      );
      Output->outputprint($docO,$outputdev);
   }
   else {
      $bodyO->aT("p",{},"Zmna hesla byla provedena.");
      Output->outputprint($docO,$outputdev);
      open(STDOUT, ">/dev/null");
      program->password();
   }
}

sub oldpassword {
   return $query->param("oldpassword");
}

sub newpassword {
   return $query->param("newpassword");
}

sub renewpassword {
   return $query->param("renewpassword");
}

sub newpassword_isnotok {
   my ($userpom,$passwordpom,$why);
   while (($userpom,$passwordpom)=getpwent) {
      last if($userpom eq My->remote_user);
   }
   if(!defined(oldpassword())) {
      $why="Nebylo zadno star heslo.";
   }
   elsif(!defined(newpassword())) {
      $why="Nebylo zadno nov heslo.";
   }
   elsif(newpassword() ne renewpassword()) {
      $why="Nov heslo bylo po druh zadno jinak.";
   }
   elsif(newpassword() eq oldpassword()) {
      $why="Nov heslo mus bt jin ne star.";
   }
   elsif($passwordpom ne crypt(oldpassword(),$passwordpom)) {
      $why="Star heslo nebylo zadno dobe.";
   }
   elsif(length(newpassword())<6 or length(newpassword())>8) {
      $why="Nov heslo m patnou dlku - sprvn m mt 6 a 8 znak.";
   }
   elsif(newpassword()=~/[^0-9A-Za-z\/\*\-\+\.]/) {
      $why="Nov heslo me obsahovat jen psmena anglick abecedy a slice a znaky / * - + ..";
   }
   return $why;
}

sub password {
  my $service = "passwd";
  my $pamh;
  ref($pamh = new Authen::PAM($service, My->remote_user, \&my_conv_func)) ||
         die "Error code $pamh during PAM init!";
  $pamh->pam_chauthtok;
}

sub my_conv_func {
   my @res;
   while ( @_ ) {
      my $code = shift;
      my $msg = shift;
      my $ans = "";
      $ans = My->remote_user if ($code == PAM_PROMPT_ECHO_ON() );
      if ($code == PAM_PROMPT_ECHO_OFF() ) {
         $ans = oldpassword() if ($state == 0);
         $ans = newpassword() if ($state == 1);
         $ans = newpassword() if ($state == 2);
         $state++;
      }
      push @res, (PAM_SUCCESS(),$ans);
   }
   push @res, PAM_SUCCESS();
   return @res;
}

