package Front;

my $pkg="Front";

use strict;
use My;
use MyXML;
use Info;
use Forum;
use Date::Format;
use Class::Date qw(date);

my $dbh=My->dbh;


#=== Fce tykajici se narozenin a svatku

#- fce doplnujici do $tO html kod o svatcich a narozeninach
sub celebrations {
   my ($pkg_p, $tO)=@_;
   my $datenow=My->date_now;
   my $oddata=My->date_addday($datenow,-1);
   my $dodata=My->date_addday($datenow,15);
   my $yoddata=1*substr($oddata,0,4);
   my $moddata=1*substr($oddata,5,2);
   my $cel;
   # narozeniny
   my $sth=$dbh->prepare(q{
      select
         Zamestnanci.datum_nar as datnar,
         concat(
            if(month(Zamestnanci.datum_nar)>=?,?,?),
            "-",
            substring(Zamestnanci.datum_nar,6)
         ) as datcel,
         Zamestnanci.oc
      from
         Zamestnanci.Zamestnanci
      where
         Zamestnanci.platod<=? and
         Zamestnanci.platdo>=? and
         concat(
            if(month(Zamestnanci.datum_nar)>=?,?,?),
            "-",
            substring(Zamestnanci.datum_nar,6)
         )>=? and
         concat(
            if(month(Zamestnanci.datum_nar)>=?,?,?),
            "-",
            substring(Zamestnanci.datum_nar,6)
         )<=?
   });
   $sth->execute(
      $moddata,$yoddata,($yoddata+1),
      get_env("datum"),get_env("datum"),
      $moddata,$yoddata,($yoddata+1),
         $oddata,
      $moddata,$yoddata,($yoddata+1),
         $dodata
   );
   while(my $ref=$sth->fetchrow_hashref) {
      my $ydatcel=substr($$ref{datcel},0,4);
      my $ydatnar=substr($$ref{datnar},0,4);
      $$cel{$$ref{datcel}}{$$ref{oc}}{1}= "narozeniny" . " (" . ($ydatcel-$ydatnar) . ")";
   }
   $sth->finish;
   # svatky
   my $sth_zam=$dbh->prepare(q{
      select
         Zamestnanci.oc
      from
         Zamestnanci.Zamestnanci
      where
         Zamestnanci.jmeno=? and
         Zamestnanci.platod<=? and
         Zamestnanci.platdo>=?
   });
   my $sth=$dbh->prepare(q{
      select
         Svatky.jmeno,
         concat(
            if((1*substring(Svatky.datum,1,2))>=?,?,?),
            "-",
            Svatky.datum
         ) as datcel
      from
         Zamestnanci.Svatky
      where
         concat(
            if((1*substring(Svatky.datum,1,2))>=?,?,?),
            "-",
            Svatky.datum
         )>=? and
         concat(
            if((1*substring(Svatky.datum,1,2))>=?,?,?),
            "-",
            Svatky.datum
         )<=? and
         Svatky.porc="0"
   });
   $sth->execute(
      $moddata,$yoddata,($yoddata+1),
      $moddata,$yoddata,($yoddata+1),
         $oddata,
      $moddata,$yoddata,($yoddata+1),
         $dodata
   );
   while(my $ref=$sth->fetchrow_hashref) {
      $sth_zam->execute($$ref{jmeno},get_env("datum"),get_env("datum"));
      while(my $ref_zam=$sth_zam->fetchrow_hashref) {
         $$cel{$$ref{datcel}}{$$ref_zam{oc}}{2}= "svtek";
      }
      $sth_zam->finish;
   }
   $sth->finish;
   # tisk
   my $divO;
   if(defined($cel)) {
      $divO=$tO->aT("div", { style => "font-family: Arial; font-size: 60%; margin-top: 10px;" } );
      my @wdayname=("Ne","Po","t","St","t","P","So");
      foreach my $datcel (sort keys %{$cel}) {
         foreach my $oc (sort keys %{$$cel{$datcel}}) {
            my $info_oc=Info->oc($oc);
            foreach my $celtyp (sort keys %{$$cel{$datcel}{$oc}}) {
               my $dateprac=date($datcel);
               my $wday=$dateprac->_wday;
               my $datcelprint=substr($datcel,5);
               $datcelprint=~/^(\d\d)-(\d\d)$/;
               $datcelprint= (1*$2) . "." . (1*$1) . ".";
               my $text;
               my $style;
               if($datcel eq $datenow) {
                  $text= "Dnes m ";
                  $style="color: red;";
               }
               elsif($datcel gt $datenow) {
                  $text= $wdayname[$wday] . " " . $datcelprint . " m ";
               }
               else {
                  $text= $wdayname[$wday] . " " . $datcelprint;
                  if($$info_oc{pohlavi} ne "ena") {
                     $text.=" ml ";
                  }
                  else {
                     $text.=" mla ";
                  }
               }
               my $divOO=$divO->aT("div", { style=>$style }, $text . $$info_oc{jmeno} . " " . $$info_oc{prijmeni});
               if(length($$info_oc{str}) or length($$info_oc{funkce_nazev})) {
                  $divOO->aT(undef, {}, " (");
                  if(length($$info_oc{str})) {
                     $divOO->aT(undef, {}, $$info_oc{str});
                  }
                  if(length($$info_oc{str}) and length($$info_oc{funkce_nazev})) {
                     $divOO->aT(undef, {}, " - ");
                  }
                  if(length($$info_oc{funkce_nazev})) {
                     $divOO->aT(undef, {}, $$info_oc{funkce_nazev});
                  }
                  $divOO->aT(undef, {}, ")");
               }
               $divOO->aT(undef, {}, " " . $$cel{$datcel}{$oc}{$celtyp});
            }
         }
      }
   }
}


#=== Fce tykajici se fora

#- fce doplnujici do $tO html kod o novych prispevcich ci prispevcich s puncem 3
sub forum {
   my ($pkg_p, $tO,$forumodb)=@_;
   my $sth=$dbh->prepare(q{
      select
         Forum_odber.forum
      from
         Komunikace.Forum_odber
      where
         Forum_odber.uzivzapis=?
      order by
         Forum_odber.datzapis asc
   });
   my $sth_prispevky=$dbh->prepare(q{
      select distinct
         Forum.*
      from
         Komunikace.Forum
         left join Komunikace.Forum_punc on (Forum.forum=Forum_punc.forum and Forum.id=Forum_punc.id and Forum_punc.uzivzapis=?)
      where
         Forum.forum=? and
         Forum_punc.uzivzapis is null and
         Forum.datzapis>=?
      order by
         Forum.datzapis desc
      limit
         3
   });
   my $sth_prispevkypunc=$dbh->prepare(q{
      select distinct
         Forum.*
      from
         Komunikace.Forum
         inner join Komunikace.Forum_punc on (Forum.forum=Forum_punc.forum and Forum.id=Forum_punc.id and Forum_punc.uzivzapis=?)
      where
         Forum.forum=? and
         Forum_punc.punc>=?
      order by
         Forum.datzapis desc
      limit
         50
   });
   my @fora;
   if(!defined($forumodb)) {
      my $odber=Forum->odber;
      foreach my $forum (sort keys %{$odber}) {
         if($$odber{$forum} and My->pravo(My->remote_user,$forum)) {
            push(@fora,$forum);
         }
      }
      $sth->execute(My->remote_user);
      while(my $ref=$sth->fetchrow_hashref) {
         if(!defined($$odber{$$ref{forum}}) and My->pravo(My->remote_user,$$ref{forum})) {
            push(@fora,$$ref{forum});
         }
      }
      $sth->finish;
   }
   else {
      push(@fora,$forumodb);
   }
   my $div1O;
   if(!defined($forumodb)) {
      $div1O=$tO->aT("div", { style => "font-family: Arial; font-size: 60%; margin-top: 10px;" } );
   }
   else {
      $div1O=$tO->aT("div", { style => "font-family: Arial; font-size: 60%;" } );
   }
   my $oddata=time2str("%Y-%m-%d", time-(30*24*60*60)); # 30 dni
   foreach my $forum (@fora) {
      my $nalezeno_forum=0;
      my $div2O=$div1O->aT("div");
      if(!defined($forumodb)) {
         $div2O->aT("a", { style => "text-decoration: none;", href => Forum->forumpath . "show.phtml?forum=" . encode_uri($forum) }, Forum->forum_name_title($forum));
      }
      my $ulO=$div2O->aT("ul", { style => "margin-top: 0px; margin-bottom: 0px;" });
      # Neopuncovane prispevky
      $sth_prispevky->execute(My->remote_user,$forum,$oddata);
      while(my $ref_prispevky=$sth_prispevky->fetchrow_hashref) {
         $nalezeno_forum=1;
         $pkg->forum_telo($ulO,$ref_prispevky);
      }
      # Prispevky s puncem 3
      $sth_prispevkypunc->execute(My->remote_user,$forum,"3");
      while(my $ref_prispevkypunc=$sth_prispevkypunc->fetchrow_hashref) {
         $nalezeno_forum=1;
         $pkg->forum_telo($ulO,$ref_prispevkypunc,"red");
      }
      if(!$nalezeno_forum) {
         $div1O->removeChild($div2O);
      }
   }
   if(!defined($forumodb)) {
      $tO->aT("p"); # prazdny odstavec kvuli oddeleni textu v links
   }
}

#- pomocna fce k fci forum
sub forum_telo {
   my ($pkg_p, $tO, $ref_prispevky,$color)=@_;
   my $liO=$tO->aT("li");
   $liO->aT("a", { style => "text-decoration: none; color: $color;", href => Forum->forumpath . "show.phtml?forum=" . encode_uri($$ref_prispevky{forum}) . "&id=" . $$ref_prispevky{id} }, $$ref_prispevky{predmet});
   $liO->aT(undef, {}, " ");
   my $Edatum=get_env("datum");
   set_env("datum",$$ref_prispevky{datzapis});
   my $info_oc=Info->uziv($$ref_prispevky{uzivzapis},{uziv=>1,zamfce=>1});
   set_env("datum",$Edatum);
   $liO->aT(undef, {}, $$info_oc{jmeno} . " " . $$info_oc{prijmeni});
   if(length($$info_oc{str}) or length($$info_oc{funkce_nazev})) {
      $liO->aT(undef, {}, " (");
      if(length($$info_oc{str})) {
         $liO->aT(undef, {}, $$info_oc{str});
      }
      if(length($$info_oc{str}) and length($$info_oc{funkce_nazev})) {
         $liO->aT(undef, {}, " - ");
      }
      if(length($$info_oc{funkce_nazev})) {
         $liO->aT(undef, {}, $$info_oc{funkce_nazev});
      }
      $liO->aT(undef, {}, ")");
   }
   $liO->aT(undef, {}, " ");
   $liO->aT(undef, {}, substr($$ref_prispevky{datzapis},0,16));
}

#- fce vracejici datum posledni aktualizace v zadanem Foru
sub forumlastpost {
   my ($pkg_p,$forum)=@_;
   my $sth=$dbh->prepare(q{
      select
         Forum.datzapis
      from
         Komunikace.Forum
      where
         Forum.forum=?
      order by
         Forum.datzapis desc
      limit
         1
   });
   $sth->execute($forum);
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   return $$ref{datzapis};
}


return 1;

