package Kusovnik;

my $pkg="Kusovnik";

use strict;
use My;

my $dbh=My->dbh;


#- inicializace vazby na 0tem sledu
sub ini {
   my ($pkg_p, $vazba)=@_;
   $$vazba{sled}=0;
   $$vazba{zakv}=undef;
   $$vazba{zakn}=$$vazba{zak};
   $$vazba{ind}=0 if(!defined($$vazba{ind}));
   $$vazba{indc}=$$vazba{ind} if(!defined($$vazba{indc}));
   $$vazba{mnoz}=1 if(!defined($$vazba{mnoz}));
   $$vazba{mnozc}=$$vazba{mnoz} if(!defined($$vazba{mnozc}));
   $$vazba{mnozczm}=$$vazba{mnoz} if(!defined($$vazba{mnozczm})); # ma vyznam u rozpadu v Kusovnik_norm.pm jinak je totozne s $$vazba{mnozc}
   $$vazba{_indmax}=1 if(!defined($$vazba{_indmax}));
   $$vazba{_table}="Zakazky.Kusovnik" if(!defined($$vazba{_table}));
   return $vazba;
}

#- inicializace vazby na 0tem sledu u inverzniho kusovniku
sub invini {
   my ($pkg_p, $vazba)=@_;
   $$vazba{sled}=0;
   $$vazba{zakv}=$$vazba{zak};
   $$vazba{zakn}=undef;
   $$vazba{ind}=0 if(!defined($$vazba{ind}));
   $$vazba{mnoz}=1 if(!defined($$vazba{mnoz}));
   $$vazba{mnozc}=$$vazba{mnoz} if(!defined($$vazba{mnozc}));
   $$vazba{mnozczm}=$$vazba{mnoz} if(!defined($$vazba{mnozczm})); # ma vyznam u rozpadu v Kusovnik_norm.pm jinak je totozne s $$vazba{mnozc}
   $$vazba{_table}="Zakazky.Kusovnik" if(!defined($$vazba{_table}));
   return $vazba;
}

#- zakladni kusovnik (vraci 1 kdyz doslo k rozpadu jinak 0)
sub kusovnik {
   my ($pkg_p, $vazba)=@_;
   my $sled=$$vazba{sled}+1;
   # zajisteni pripadneho serazeni - tuhle moznost jsem z duvodu rychlosti vyradil - vzdy radim dle zakn
   my $sth_kus=$dbh->prepare(q{
      select
         zakv,
         zakn,
         ind,
         mnoz,
         pozice
      from
   }
      . $$vazba{_table} .
   q{
      where
         zakv=? and
         platod<=? and
         platdo>=? and
         ind<=?
   });
   $sth_kus->execute($$vazba{zakn},get_env("datum"),get_env("datum"),$$vazba{_indmax});
   my $rozpad=0;
   while(my $ref_kus=$sth_kus->fetchrow_hashref) {
      $rozpad=1;
      my $indc;
      if($$vazba{indc}>$$ref_kus{ind}) {
         $indc=$$vazba{indc};
      }
      else {
         $indc=$$ref_kus{ind};
      }
      #- predani spracovani externi fci
      my ($pkg_fce,$fce)=split(/\-\>/,$$vazba{_funkce});
      # vytvoreni nove vzaby
      my %vazba=%$vazba;
      # zmena udaju v nove vazbe
      $vazba{sled}=$sled;
      $vazba{zakv}=$$ref_kus{zakv};
      $vazba{zakn}=$$ref_kus{zakn};
      $vazba{ind}=$$ref_kus{ind};
      $vazba{mnoz}=$$ref_kus{mnoz};
      $vazba{pozice}=$$ref_kus{pozice};
      $vazba{indc}=$indc;
      $vazba{mnozc}=$$vazba{mnozc}*$$ref_kus{mnoz};
      $vazba{mnozczm}=$$vazba{mnozczm}*$$ref_kus{mnoz};
      $pkg_fce->$fce(\%vazba);
   }
   $sth_kus->finish;
   return $rozpad;
}

#- zakladni inverzni kusovnik (vraci 1 kdyz doslo k inverznimu rozpadu jinak 0)
sub invkusovnik {
   my ($pkg_p, $vazba)=@_;
   my $sled=$$vazba{sled}+1;
   my $sth_kus=$dbh->prepare(q{
      select
         zakv,
         zakn,
         ind,
         mnoz,
         pozice
      from
   }
      . $$vazba{_table} .
   q{
      where
         zakn=? and
         platod<=? and
         platdo>=?
   });
   $sth_kus->execute($$vazba{zakv},get_env("datum"),get_env("datum"));
   my $rozpad=0;
   while(my $ref_kus=$sth_kus->fetchrow_hashref) {
      $rozpad=1;
      #- predani spracovani externi fci
      my ($pkg_fce,$fce)=split(/\-\>/,$$vazba{_funkce});
      # vytvoreni nove vzaby
      my %vazba=%$vazba;
      # zmena udaju v nove vazbe
      $vazba{sled}=$sled;
      $vazba{zakv}=$$ref_kus{zakv};
      $vazba{zakn}=$$ref_kus{zakn};
      $vazba{ind}=$$ref_kus{ind};
      $vazba{mnoz}=$$ref_kus{mnoz};
      $vazba{pozice}=$$ref_kus{pozice};
      $vazba{mnozc}=$$vazba{mnozc}*$$ref_kus{mnoz};
      $vazba{mnozczm}=$$vazba{mnozczm}*$$ref_kus{mnoz};
      $pkg_fce->$fce(\%vazba);
   }
   $sth_kus->finish;
   return $rozpad;
}

#- vraci sortiment na zaklade finalu a predtim urceneho sortimentu
sub sor {
   my ($pkg_p,$zak,$sor)=@_;
   if(Kusovnik->sor_dulezitost($zak)>Kusovnik->sor_dulezitost($sor)) {
      $sor=$zak;
   }
   ## ZMENA 2002-09-18: drive tu bylo jen "else" a ne nize uvedene "elsif" !!!!!
   elsif(Kusovnik->sor_dulezitost($zak)==Kusovnik->sor_dulezitost($sor)) {
      $sor=My->str_intersection($zak,$sor);
   }
   return $sor;
}

#- vraci zakaznika - jde o analogii fce sor
sub zakaznikico {
   my ($pkg_p, $zakaznikiconew,$zakaznikico)=@_;
   if(!defined($zakaznikico)) {
      $zakaznikico=$zakaznikiconew;
   }
   elsif(length($zakaznikiconew) and $zakaznikico ne $zakaznikiconew) {
      $zakaznikico="";
   }
   return $zakaznikico;
}

#- vraci hodnotu dulezitosti zakazky - pro urcovani sortimentu
sub sor_dulezitost {
   my ($pkg_p,$zak)=@_;
   my $dulezitost;
   if(length($zak)) {
      my $pate=1*substr($zak,4,1);
      if($pate>=1 and $pate<=7) {   # finaly
         $dulezitost=9;
      }
      elsif($pate==8) {   # prislusenstvi
         $dulezitost=2;
      }
      elsif($pate==9) {
         $dulezitost=1;
      }
      else {
         $dulezitost=0;
      }
   }
   else {
      $dulezitost=-1;
   }
   return $dulezitost;
}

#================================================================#
# Blok funkci slouzici k vytvoreni tabulky s docasnym kusovnikem #
# z inverzniho kusovniku (tabulka bude obsahovat prave jen vazby #
# z inverzniho kusovniku) - vhodne pro nasledny pruchod z vrchu  #
#================================================================#
#- hlavni funkce vytvarejici docasny kusovnik
sub invkusovnik_temp {
   my ($pkg_p, $vazba)=@_;
   # vytvoreni nove vazby
   my %vazba=%$vazba;
   # vytvoreni docasne tabulku kusovnik
   $vazba{_sth_ins}=$pkg->invkusovnik_crea($vazba{_temptable});
   # vyvolani plneni docasneho kusovniku
   $pkg->invkusovnik_write(
      $pkg->invini(\%vazba)
   );
}
# pomocna fce zapisujici do docasneho kusovniku
sub invkusovnik_write {
   my ($pkg_p, $vazba)=@_;
   if($$vazba{sled}!=0) {
      $$vazba{_sth_ins}->execute(
         $$vazba{zakv},
         $$vazba{zakn},
         "0000-00-00",
         "9999-12-31",
         $$vazba{ind},
         $$vazba{mnoz},
         $$vazba{pozice}
      );
   }
   # pokracuj v rozpadu
   my $rozpad=$pkg->invkusovnik($vazba);
   # pokud jiz nedojde k rozpadu zapis umelou nejvyssi vazbu, kde zakv="-"
   if(!$rozpad) {
      $$vazba{_sth_ins}->execute(
         "-",
         $$vazba{zakv},
         "0000-00-00",
         "9999-12-31",
         "0",
         "1",
         ""
      );
   }
   return $rozpad;
}
# pomocna fce vytvarejici tabulku pro docasny kusovnik
sub invkusovnik_crea {
   my ($pkg_p, $table)=@_;
   my $sth_crea=$dbh->prepare(q{
      CREATE TEMPORARY TABLE } . $table . q{ (
         zakv varchar(14) NOT NULL default '',
         zakn varchar(14) NOT NULL default '',
         platod date NOT NULL default '0000-00-00',
         platdo date NOT NULL default '0000-00-00',
         ind char(1) NOT NULL default '',
         mnoz decimal(8,3) NOT NULL default '0.000',
         pozice varchar(6) NOT NULL default '',
         PRIMARY KEY  (zakv,zakn,platod),
         KEY zakn (zakn)
      )
   });
   $sth_crea->execute;
   my $sth_ins=$dbh->prepare(q{
      insert ignore into } . $table . q{
         values (?,?,?,?,?,?,?)
   });
   return $sth_ins;
}
# pomocna fce mazajici docasny kusovnik
sub invkusovnik_drop {
   my ($pkg_p, $table)=@_;
   my $sth_drop=$dbh->prepare(q{
      DROP TABLE } . $table . q{ 
   });
   $sth_drop->execute;
}

return 1;

