package Kusovnik_zob;

# Knihovna slouzi k zobrazovani kusovniku

my $pkg="Kusovnik_zob";

use strict;
use lib ("/home/web-mycompany/www/lib");
use My;
use MyXML;
use Link;
use Format;
use Output;
use Info;
use Kusovnik;
use Vyroba_priprava;


#==== Globalni promena tohohle balicku
my ($kustypmenu,$kustypmenunazev)=Vyroba_priprava->kustypmenu;
my $ch=Vyroba_priprava->chseznam;


#==== Napojeni na DB
my $dbh=My->dbh;
# dotaz pro praci s Vyroba_stav, ale pro kmint 999 a 998 - zde scitam stav na vsech strediscich
my $sth_stav_999=$dbh->prepare(q{
   select
      sum(Vyroba_stav.ksvych+Vyroba_stav.ksprij-Vyroba_stav.kszm-Vyroba_stav.ksodv) as ks
   from
      Vyroba_evidence.Vyroba_stav
   where
      Vyroba_stav.org=? and
      Vyroba_stav.zak=? and
      Vyroba_stav.kmint in("998","999") and
      (Vyroba_stav.ksvych+Vyroba_stav.ksprij-Vyroba_stav.kszm-Vyroba_stav.ksodv)>0
});
# dotaz zjistujici celkovou prubeznou dobu zakazky z normativu
my $sth_pdsum=$dbh->prepare(q{
   select
      sum(Normativy.pd) as pdsum
   from
      Vyroba_planovani.Normativy
   where
      Normativy.zak=? and
      Normativy.platod<=? and
      Normativy.platdo>=?
});
# dotaz zjistujici normativ
my $sth_norm=$dbh->prepare(q{
   select
      Normativy.*
   from
      Vyroba_planovani.Normativy
   where
      Normativy.zak=? and
      Normativy.platod<=? and
      Normativy.platdo>=?
   order by
      Normativy.kmint asc
});


#==== Vystupni funkce ====#
sub zobkus {
   my ($pkg_p, $polozky,$idcs,$outputdev)=@_;
   if($$polozky{kustyp}{value} eq "strom" or $$polozky{kustyp}{value} eq "kde") {
      $$outputdev{bezpre}=1;
   }
   # vytvoreni html dokumentu
   my ($docO,$htmlO,$bodyO);
   ($docO,$htmlO,$bodyO,$$outputdev{prvniradek})=MyXML->creahtml($outputdev,$idcs);
   my $outputvar=[["Zak:",Format->zak($$polozky{zak}{value})],["Typ kusovnku:",$$kustypmenunazev{$$polozky{kustyp}{value}}],["Platnost:",get_env("datum")]];
   if($$polozky{kustyp}{value} eq "strom" or $$polozky{kustyp}{value} eq "kde") {
      push(@{$outputvar},["Zob.stav:",$$polozky{kusDstav}{value}],["Zob.pd:",$$polozky{kusDpd}{value}],["Zob.norm:",$$polozky{kusDnorm}{value}],["Zob.tV:",$$polozky{kusDtv}{value}]);
   }
   if($$polozky{kustyp}{value} eq "strom" or $$polozky{kustyp}{value} eq "souhrn") {
      if(My->pravo(My->remote_user,'/Vyroba_ceny/Vnitr_ceny/zobvc.phtml')) {
         push(@{$outputvar},["Zob.VN:",$$polozky{kusDuvn}{value}]);
      }
   }
   if($$polozky{kustyp}{value} ne "kde3738") {
      push(@{$outputvar},["Omezen na kmorg:",$$polozky{kuskmorg}{value}]);
   }
   $$outputdev{prvniradek}=Output->outputvar($bodyO,$outputvar,$outputdev);
   #======= TABLULKY ========#
   # vytvoreni xml dokumentu i s korenem table
   my ($docI,$table,$cols,$rows)=MyXML->creatable;
   my $doplnky={
      kusDstav=>$$polozky{kusDstav}{value},
      kusDpd=>$$polozky{kusDpd}{value},
      kusDnorm=>$$polozky{kusDnorm}{value},
      kuskmorg=>$$polozky{kuskmorg}{value}
   };
   if($$polozky{kustyp}{value} ne "kde") {
      $$doplnky{kusDtv}=$$polozky{kusDtv}{value};
   }
   if(My->pravo(My->remote_user,'/Vyroba_ceny/Vnitr_ceny/zobvc.phtml')) {
      $$doplnky{kusDuvn}=$$polozky{kusDuvn}{value};
   }
   if($$polozky{kustyp}{value} eq "strom" or $$polozky{kustyp}{value} eq "kde") {
      # popis sloupcu
      $cols->aT("col",{formatfce=>"zak"},"Zak");
      $cols->aT("col",{},"Nzev");
      $cols->aT("col",{},"(Ch/KmOrg/VykrOrg)");
      $cols->aT("col",{},"Mno");
      $cols->aT("col",{},"MnoC");
      if($$polozky{kusDstav}{value}) {
         $cols->aT("col",{},"(StavKmOrg/StavVykrOrg)");
      }
      if($$polozky{kusDpd}{value} or $$polozky{kusDnorm}{value}) {
         $cols->aT("col",{},"(Pd)");
      }
      my (%kusovnik,%infozak);
      my $info_zak=Info->zak($$polozky{zak}{value});
      $infozak{$$polozky{zak}{value}}=$info_zak;
      my ($zak,$zakappend,$kusovniktable);
      if($$polozky{kustyp}{value} eq "kde") {
         $zak="-";
         $zakappend=$zak;
         $kusovniktable="test.Kusovnik";
         # Vytvoreni pracovniho kusovniku - z inverzniho kusovniku
         Kusovnik->invkusovnik_temp(
            Kusovnik->invini({
               zak =>            $$polozky{zak}{value},
               mnoz =>           1,
               _funkce =>        "$pkg->kusovnikkde",
               _temptable =>     $kusovniktable,
               _kusovnik =>      \%kusovnik
            })
         );
      }
      else {
         $zak=$$polozky{zak}{value};
         $zakappend="";
         $kusovniktable=undef;
      }
      # poznamka: nyni i nulty sled prohanim zaznamenavajici funkci (aby se zjistili pripadne udaje pro doplnky)
      $pkg->kusovnikstrom(
         Kusovnik->ini({
            zak =>            $zak,
            mnoz =>           1,
            _indmax =>        9,
            _funkce =>        "$pkg->kusovnikstrom",
            _kusovnik =>      \%kusovnik,
            _infozak =>       \%infozak,
            _doplnky =>       $doplnky,
            _table =>         $kusovniktable
         })
      );
      # je treba nadefinovat souhrny pro nulty sled (v inverznim kusovniku by v 0 sledu asi nikdy nemelo nic pocatecniho byt, takze neni problem)
      my %souhrny=(
         pd => $kusovnik{''}{$zak}{pd}
      );
      ## ZMENA 2003-06-23 - poznamku nize jsem jiz aplikoval (v promene $zakappend je "" u typu kusovniku strom)
      # !! kdybych chtel aby uplne na vrsku byla i rozpadana zak dam jako druhy parametr prazdny retezec "" (misto $zak)
      # zjisteni kusovniku
      $pkg->append_kusovniklist(
         $rows,
         {
            kustyp => $$polozky{kustyp}{value},
            zak => $$polozky{zak}{value}
         },
         $zakappend,
         \%kusovnik,
         \%infozak,
         0,
         $$info_zak{kmorg},
         $doplnky,
         \%souhrny
      );
      # vystup
      $$outputdev{prvniradek}=Output->output(
         $bodyO,
         $table,
         $outputdev,
         "list"
      );
   }
   elsif($$polozky{kustyp}{value} eq "souhrn" or $$polozky{kustyp}{value} eq "kde3738") {
      # popis sloupcu
      $cols->aT("col",{},"*");
      $cols->aT("col",{formatfce=>"zak"},"Zak");
      $cols->aT("col",{},"Nzev");
      $cols->aT("col",{},"Ch");
      $cols->aT("col",{},"KO");
      $cols->aT("col",{},"VO");
      $cols->aT("col",{},"Mno");
      my $doplnkytable;
      if($$doplnky{kusDuvn}) {
         $cols->aT("col",{type=>"number",format=>"#,##0.00"},"Pid.hodn.");
         $cols->aT("col",{type=>"number",format=>"#,##0.00"},"VN");
         push(@{$doplnkytable},("uvnpridana","uvn"));
      }
      # zjisteni kusovniku
      my (%kusovnik,%infozak);
      my $prog="$pkg->kusovnik".$$polozky{kustyp}{value};
      my $info_zak=Info->zak($$polozky{zak}{value});
      $infozak{$$polozky{zak}{value}}=$info_zak;
      if($$polozky{kustyp}{value} eq "kde3738") {
         Kusovnik->invkusovnik(
            Kusovnik->invini({
               zak =>            $$polozky{zak}{value},
               mnoz =>           1,
               _indmax =>        9,
               _funkce =>        $prog,
               _kusovnik =>      \%kusovnik,
               _infozak =>       \%infozak,
               _kuskmorg =>      $$polozky{kuskmorg}{value}
            })
         );
         $pkg->append_kusovniktable(
            $rows,
            {
               kustyp => $$polozky{kustyp}{value},
               zak => $$polozky{zak}{value}
            },
            $$polozky{zak}{value},
            \%kusovnik,
            \%infozak,
            $idcs
         );
      }
      else {
         Kusovnik->kusovnik(
            Kusovnik->ini({
               zak =>            $$polozky{zak}{value},
               mnoz =>           1,
               _indmax =>        9,
               _funkce =>        $prog,
               _kusovnik =>      \%kusovnik,
               _infozak =>       \%infozak,
               _doplnky =>       $doplnky,
               _kuskmorg =>      $$polozky{kuskmorg}{value}
            })
         );
         $pkg->append_kusovniktable(
            $rows,
            {
               kustyp => $$polozky{kustyp}{value},
               zak => $$polozky{zak}{value}
            },
            $$polozky{zak}{value},
            \%kusovnik,
            \%infozak,
            $idcs,
            $doplnkytable
         );
      }
      # vystup
      $$outputdev{prvniradek}=Output->output(
         $bodyO,
         $table,
         $outputdev
      );
   }
   elsif($$polozky{kustyp}{value} eq "nizsi" or $$polozky{kustyp}{value} eq "vyssi") {
      # popis sloupcu
      $cols->aT("col",{},"*");
      $cols->aT("col",{formatfce=>"zak"},"Zak");
      $cols->aT("col",{},"Nzev");
      $cols->aT("col",{},"Ch");
      $cols->aT("col",{},"KO");
      $cols->aT("col",{colbreak=>1},"VO");
      $cols->aT("col",{type=>"date"},"PlatOd");
      $cols->aT("col",{type=>"date"},"PlatDO");
      $cols->aT("col",{},"I");
      $cols->aT("col",{},"Mno");
      $cols->aT("col",{},"Poz");
      $cols->aT("col",{type=>"date",format=>"yyyy-MM-dd"},"DatZpis");
      $cols->aT("col",{},"UivZpis");
      # zjisteni kusovniku
      my (%kusovnik,%infozak);
      my $prog="$pkg->kusovnik".$$polozky{kustyp}{value};
      my $info_zak=Info->zak($$polozky{zak}{value});
      $infozak{$$polozky{zak}{value}}=$info_zak;
      if($$polozky{kustyp}{value} eq "nizsi") {
         $pkg->kusovniknizsi(
            {
               zak =>            $$polozky{zak}{value},
               mnoz =>           1,
               _kusovnik =>      \%kusovnik,
               _infozak =>       \%infozak,
               _kuskmorg =>      $$polozky{kuskmorg}{value}
            }
         );
      }
      else {
         $pkg->kusovnikvyssi(
            {
               zak =>            $$polozky{zak}{value},
               mnoz =>           1,
               _kusovnik =>      \%kusovnik,
               _infozak =>       \%infozak,
               _kuskmorg =>      $$polozky{kuskmorg}{value}
            }
         );
      }
      $pkg->append_kusovniktable_platnost(
         $rows,
         {
            kustyp => $$polozky{kustyp}{value},
            zak => $$polozky{zak}{value}
         },
         $$polozky{zak}{value},
         \%kusovnik,
         \%infozak,
         $idcs
      );
      # vystup
      $$outputdev{prvniradek}=Output->output(
         $bodyO,
         $table,
         $outputdev
      );
   }
   elsif($$polozky{kustyp}{value} eq "konstr") {
      # popis sloupcu
      $cols->aT("col",{},"Poz");
      $cols->aT("col",{formatfce=>"zak"},"Zak");
      $cols->aT("col",{},"Nzev");
      $cols->aT("col",{},"KO");
      $cols->aT("col",{},"VO");
      $cols->aT("col",{},"Mno");
      $cols->aT("col",{},"F");
      $cols->aT("col",{},"Poznmka");
      # zjisteni kusovniku
      my (%kusovnik,%infozak);
      my $info_zak=Info->zak($$polozky{zak}{value});
      $infozak{$$polozky{zak}{value}}=$info_zak;
      $pkg->kusovnikkonstr(
         {
            zak =>            $$polozky{zak}{value},
            mnoz =>           1,
            _kusovnik =>      \%kusovnik,
            _infozak =>       \%infozak,
            _kuskmorg =>      $$polozky{kuskmorg}{value}
         }
      );
      $pkg->append_kusovniktable_konstr(
         $rows,
         {
            kustyp => $$polozky{kustyp}{value},
            zak => $$polozky{zak}{value}
         },
         $$polozky{zak}{value},
         \%kusovnik,
         \%infozak,
         $idcs
      );
      # vystup
      $$outputdev{prvniradek}=Output->output(
         $bodyO,
         $table,
         $outputdev
      );
   }
   #======= odeslani vystupu na vyst zarizeni
   # vlozeni informaci o zadanych parametrech
   Output->outputprint($docO,$outputdev);
}

#==== Vystupni funkce ====#
sub rozdilkus {
   my ($pkg_p, $polozky,$idcs,$outputdev)=@_;
   my ($zak1,$zak2)=($$polozky{zak}{value},$$polozky{zak2}{value});
   my ($platnost1,$platnost2)=($$polozky{platnost}{value},$$polozky{platnost2}{value});
   # vytvoreni html dokumentu
   my ($docO,$htmlO,$bodyO);
   ($docO,$htmlO,$bodyO,$$outputdev{prvniradek})=MyXML->creahtml($outputdev,$idcs);
   my $outputvar=[["Zak 1:",Format->zak($zak1)],["Platnost 1:",$platnost1],["Zak 2:",Format->zak($zak2)],["Platnost 2:",$platnost2],["Zobrazit jen rozdly:",$$polozky{rozdilkusjen}{value}],["Omezen na kmorg:",$$polozky{kuskmorg}{value}]];
   $$outputdev{prvniradek}=Output->outputvar($bodyO,$outputvar,$outputdev);
   #======= TABLULKY ========#
   # vytvoreni xml dokumentu i s korenem table
   my ($docI,$table,$cols,$rows)=MyXML->creatable;
   # popis sloupcu
   $cols->aT("col",{},"*");
   $cols->aT("col",{formatfce=>"zak"},"Zak");
   $cols->aT("col",{},"Nzev");
   $cols->aT("col",{},"Ch");
   $cols->aT("col",{},"KO");
   $cols->aT("col",{},"VO");
   $cols->aT("col",{},"Mno1");
   $cols->aT("col",{},"Mno2");
   $cols->aT("col",{},"R");
   # zjisteni kusovniku 2
   set_env("datum",$platnost2);
   my (%kusovnik2,%infozak2);
   my $info_zak2=Info->zak($zak2);
   $infozak2{$zak2}=$info_zak2;
   Kusovnik->kusovnik(
      Kusovnik->ini({
         zak =>            $zak2,
         mnoz =>           1,
         _indmax =>        1,
         _funkce =>        "$pkg->kusovniksouhrn",
         _kusovnik =>      \%kusovnik2,
         _infozak =>       \%infozak2,
         _kuskmorg =>      $$polozky{kuskmorg}{value}
      })
   );
   # zjisteni kusovniku 1
   set_env("datum",$platnost1);
   my (%kusovnik1,%infozak1);
   my $info_zak1=Info->zak($zak1);
   $infozak1{$zak1}=$info_zak1;
   Kusovnik->kusovnik(
      Kusovnik->ini({
         zak =>            $zak1,
         mnoz =>           1,
         _indmax =>        1,
         _funkce =>        "$pkg->kusovniksouhrn",
         _kusovnik =>      \%kusovnik1,
         _infozak =>       \%infozak1,
         _kuskmorg =>      $$polozky{kuskmorg}{value}
      })
   );
   # urceni rozdilu mezi kusovnikem 1 a 2
   my (%kusovnik,%infozak);
   foreach my $zakn (sort keys %{$kusovnik1{$zak1}}) {
      my $rozdil=($kusovnik1{$zak1}{$zakn}{mnozc}!=$kusovnik2{$zak2}{$zakn}{mnozc});
      if($rozdil or !$$polozky{rozdilkusjen}{value}) {
         $infozak{$zakn}=$infozak1{$zakn};
         $kusovnik{""}{$zakn}{sestava}=$kusovnik1{$zak1}{$zakn}{sestava};
         $kusovnik{""}{$zakn}{ind}=$kusovnik1{$zak1}{$zakn}{ind};
         $kusovnik{""}{$zakn}{mnozc}=$kusovnik1{$zak1}{$zakn}{mnozc};
         $kusovnik{""}{$zakn}{mnozc2}=$kusovnik2{$zak2}{$zakn}{mnozc};
         if($rozdil) {
            $kusovnik{""}{$zakn}{"*"}="*";
         }
      }
   }
   foreach my $zakn (sort keys %{$kusovnik2{$zak2}}) {
      my $rozdil=($kusovnik2{$zak2}{$zakn}{mnozc}!=$kusovnik1{$zak1}{$zakn}{mnozc});
      if(!defined($kusovnik{""}{$zakn}{mnozc}) and ($rozdil or !$$polozky{rozdilkusjen}{value})) {
         $infozak{$zakn}=$infozak2{$zakn};
         $kusovnik{""}{$zakn}{sestava}=$kusovnik2{$zak2}{$zakn}{sestava};
         $kusovnik{""}{$zakn}{ind}=$kusovnik2{$zak2}{$zakn}{ind};
         $kusovnik{""}{$zakn}{mnozc}=$kusovnik1{$zak1}{$zakn}{mnozc};
         $kusovnik{""}{$zakn}{mnozc2}=$kusovnik2{$zak2}{$zakn}{mnozc};
         if($rozdil) {
            $kusovnik{""}{$zakn}{"*"}="*";
         }
      }
   }
   # generace vystupni tabulky
   $pkg->append_kusovniktable(
      $rows,
      {
         kustyp => "rozdil"
      },
      "",
      \%kusovnik,
      \%infozak,
      $idcs,
      ["mnozc2","*"]
   );
   # vystup
   $$outputdev{prvniradek}=Output->output(
      $bodyO,
      $table,
      $outputdev
   );
   #======= odeslani vystupu na vyst zarizeni
   # vlozeni informaci o zadanych parametrech
   Output->outputprint($docO,$outputdev);
}


#==== Funkce generujici pomocnou tabulku ====#
sub creasouhrnkus_temp {
   my ($pkg_p, $vazba)=@_;
   # zjisteni kusovniku
   my (%kusovnik,%infozak);
   Kusovnik->kusovnik(
      Kusovnik->ini({
         zak =>            $$vazba{zak},
         mnoz =>           $$vazba{mnoz},
         _indmax =>        $$vazba{_indmax},
         _funkce =>        "$pkg->kusovniksouhrn",
         _kusovnik =>      \%kusovnik,
         _infozak =>       \%infozak,
         _kuskmorg =>      ""
      })
   );
   # vytvoreni docasne tabulky
   my $sth_crea=$dbh->prepare(q{
      CREATE TEMPORARY TABLE } . $$vazba{_temptable} . q{ (
         zak varchar(14) NOT NULL default '',
         mnoz decimal(8,3) NOT NULL default '0.000',
         ind char(1) NOT NULL default '',
         PRIMARY KEY  (zak)
      )
   });
   $sth_crea->execute;
   # zapis do docasne tabulky
   my $sth_ins=$dbh->prepare(q{
      insert into } . $$vazba{_temptable} . q{
         values (?,?,?)
   });
   $sth_ins->execute($$vazba{zak},"1","0");
   foreach my $zakn (sort keys %{$kusovnik{$$vazba{zak}}}) {
      if($zakn ne $$vazba{zak}) {
         $sth_ins->execute($zakn,$kusovnik{$$vazba{zak}}{$zakn}{mnozc},$kusovnik{$$vazba{zak}}{$zakn}{ind});
      }
   }
}


#--
sub kusovnikstrom {
   my ($pkg_p, $vazba)=@_;
   my $doplnky=$$vazba{_doplnky};
   # zjisteni informaci o zakazce
   my $infozak=$$vazba{_infozak};
   $$infozak{$$vazba{zakn}}=Info->zak($$vazba{zakn});
   # ulozeni kusovnikove vazby
   my $kusovnik=$$vazba{_kusovnik};
   $$kusovnik{$$vazba{zakv}}{$$vazba{zakn}}{sled}=$$vazba{sled}; # neni presne pri jedinem rozpadu muzes dojit v uplne jine vetvi k te same vazbe... (to ale nevadi ja to tu mam jen pro urceni nulteho sledu)
   $$kusovnik{$$vazba{zakv}}{$$vazba{zakn}}{mnoz}=$$vazba{mnoz};
   $$kusovnik{$$vazba{zakv}}{$$vazba{zakn}}{ind}=$$vazba{ind};
   # Doplnky
   # - stav
   if($$doplnky{kusDstav}) {
      my $orgminule;
      foreach my $typorg ("kmorg","vykrorg") {
         my $org=$pkg->org($typorg,$vazba,$infozak);
         if(defined($org) and !defined($$infozak{$$vazba{zakn}}{stav}{$typorg}) and $org ne $orgminule) {
            $orgminule=$org;
            $sth_stav_999->execute($org,$$vazba{zakn});
            my $ref_stav=$sth_stav_999->fetchrow_hashref;
            $sth_stav_999->finish;
            $$infozak{$$vazba{zakn}}{stav}{$typorg}=1*$$ref_stav{ks};
         }
      }
   }
   # - prubezna doba nebo normativ
   if($$doplnky{kusDpd} or $$doplnky{kusDnorm}) {
      my ($pdsum,$norm);
      my $org=$pkg->org("kmorg",$vazba,$infozak);
      # - normativ
      if($$doplnky{kusDnorm}) {
         $sth_norm->execute($$vazba{zakn},get_env("datum"),get_env("datum"));
         while(my $ref_norm=$sth_norm->fetchrow_hashref) {
            $pdsum+=$$ref_norm{pd};
            $norm.= "\n" . $$ref_norm{kmint} . " " . $$ref_norm{kmstr} . " " . $$ref_norm{prejstr} . " " . $$ref_norm{dav} . " " . $$ref_norm{pd} . " " . $$ref_norm{proczm} . "%";
         }
         $sth_norm->finish;
         if(defined($norm)) {
            $norm= "Kmi Kstr Pstr Dav Pd \%Zm\n--------------------------" . $norm;
         }
      }
      # - prubezna doba
      else {
         $sth_pdsum->execute($$vazba{zakn},get_env("datum"),get_env("datum"));
         my $ref_pdsum=$sth_pdsum->fetchrow_hashref;
         $sth_pdsum->finish;
         $pdsum=$$ref_pdsum{pdsum};
      }
      $$kusovnik{$$vazba{zakv}}{$$vazba{zakn}}{norm}=$norm;
      $$kusovnik{$$vazba{zakv}}{$$vazba{zakn}}{pd}=$pdsum;
   }
   # - tV
   my $AFTERkusDtv=0;
   if($$doplnky{kusDtv} and $$vazba{indc}<=1) {
      # defined kvuli tomu at to k sume pripadne v jine kusovnikove vetvi nepricitam podruhe
      if(!defined($$kusovnik{$$vazba{zakv}}{$$vazba{zakn}}{tv})) {
         $AFTERkusDtv=1;
         my $sth_vn=$dbh->prepare(q{
            select
               sum(Vykon_norma.tvmin) as tv
            from
               Vyroba_priprava.Vykon_norma
            where
               Vykon_norma.zak=? and
               Vykon_norma.platod<=? and
               Vykon_norma.platdo>=? and
               Vykon_norma.ind!="5"
         });
         $sth_vn->execute($$vazba{zakn},get_env("datum"),get_env("datum"));
         my $ref_vn=$sth_vn->fetchrow_hashref;
         if($sth_vn->rows>0) {
            $$kusovnik{$$vazba{zakv}}{$$vazba{zakn}}{tv}=$$ref_vn{tv};
            $$vazba{tv}{$$vazba{zakv}}+=$$vazba{mnoz}*$$ref_vn{tv};
         }
         $sth_vn->finish;
      }
   }
   # - UVN
   if($$doplnky{kusDuvn}) {
      my $Eorg=get_env("org");
      my $org=$pkg->orgholding("kmorg",$vazba,$infozak);
      if(defined($org)) {
         set_env("org",$org);
         my $info_uvn=Info->vnitr_ceny($$vazba{zakn},"*");
         $$kusovnik{$$vazba{zakv}}{$$vazba{zakn}}{uvn}=$$info_uvn{uvn};
         my $info_uvn=Info->vnitr_ceny($$vazba{zakn},"000");
         $$kusovnik{$$vazba{zakv}}{$$vazba{zakn}}{uvnpridana}=$$kusovnik{$$vazba{zakv}}{$$vazba{zakn}}{uvn}-$$info_uvn{uvn};
         set_env("org",$Eorg);
      }
   }
   Kusovnik->kusovnik($vazba);
   # Doplnky - po rozpadu
   # - tV - po rozpadu
   if($AFTERkusDtv) {
      $$kusovnik{_souhrny}{$$vazba{zakn}}{tv}+=$$vazba{tv}{$$vazba{zakn}};
      $$kusovnik{_souhrny}{$$vazba{zakv}}{tv}+=$$vazba{mnoz}*$$kusovnik{_souhrny}{$$vazba{zakn}}{tv};
      delete($$vazba{tv}{$$vazba{zakn}});
   }
}

#--
sub kusovnikkde {
   my ($pkg_p, $vazba)=@_;
   # pri zjistovani kam a kolik danne zakazky vstupuje uvazuji jen ty vazby, kde je indikace mensi ci rovna 1
   my $kusovnik=$$vazba{_kusovnik};
   if($$vazba{ind}<=1) {
      # zjistuji zde jen celkovou sumu kolikrat danna zakazka vstupuje do prave prave procazejici sestavy
      $$kusovnik{$$vazba{zakv}}{$$vazba{zakn}}{mnozc}+=$$vazba{mnozc}; # musim pricitat, jelikoz pri jedinem rozpadu mohu v jine vetvi dojit k te same vazbe...
   }
   # rozpadam a zapisuji
   my $rozpad=Kusovnik->invkusovnik_write($vazba);
   # pokud jiz nedojde k rozpadu, je treba zaznamenat jeste mnozc do umele kusovnikove vazby
   if(!$rozpad) {
      $$kusovnik{"-"}{$$vazba{zakv}}{mnozc}+=$$vazba{mnozc};
   }
}

#--  - ve fci probiha pripadna filtrace na pozadavek v $$vazba{_kuskmorg}
sub kusovniksouhrn {
   my ($pkg_p, $vazba)=@_;
   my $doplnky=$$vazba{_doplnky};
   # v souhrnem kusovniku najizdim jen ty vazby, kde je indikace mensi ci rovna 1
   if($$vazba{ind}<=1) {
      # zjisteni informaci o zakazce
      my $infozak=$$vazba{_infozak};
      $$infozak{$$vazba{zakn}}=Info->zak($$vazba{zakn});
      # pokud je omezeni na nejakou kmorg - je treba "priradit" u zakazek s kmorg 0 kmorg org vyssi
      my $neuvazuj;
      if($$vazba{_kuskmorg} ne "") {
         if($$infozak{$$vazba{zakn}}{kmorg} eq "0") {
            if($$infozak{$$vazba{zakv}}{kmorg} ne $$vazba{_kuskmorg}) {
               $neuvazuj=1;
            }
         }
         elsif($$infozak{$$vazba{zakn}}{kmorg} ne $$vazba{_kuskmorg}) {
            $neuvazuj=1;
         }
      }
      # ulozeni kusovnikove vazby
      if(!$neuvazuj) {
         my $kusovnik=$$vazba{_kusovnik};
         $$kusovnik{$$vazba{zak}}{$$vazba{zakv}}{sestava}=1;
         $$kusovnik{$$vazba{zak}}{$$vazba{zakn}}{mnozc}+=$$vazba{mnozc};
         # teoreticky pokud je dana vazba v kusovniku ve vice vetvych, muze byt jednou indc=0 a jindy indc=1 - pak nahodne vyberu
         $$kusovnik{$$vazba{zak}}{$$vazba{zakn}}{ind}=$$vazba{indc};
         # Doplnky
         # - UVN
         if($$doplnky{kusDuvn}) {
            my $Eorg=get_env("org");
            my $org=$pkg->orgholding("kmorg",$vazba,$infozak);
            if(defined($org)) {
               set_env("org",$org);
               my $info_uvn=Info->vnitr_ceny($$vazba{zakn},"*");
               $$kusovnik{$$vazba{zak}}{$$vazba{zakn}}{uvn}=$$info_uvn{uvn};
               my $info_uvn=Info->vnitr_ceny($$vazba{zakn},"000");
               $$kusovnik{$$vazba{zak}}{$$vazba{zakn}}{uvnpridana}=$$kusovnik{$$vazba{zak}}{$$vazba{zakn}}{uvn}-$$info_uvn{uvn};
               set_env("org",$Eorg);
            }
         }
      }
      Kusovnik->kusovnik($vazba);
   }
}

#--  - ve fci probiha pripadna filtrace na pozadavek v $$vazba{_kuskmorg}
sub kusovniknizsi {
   my ($pkg_p, $vazba)=@_;
   # dotaz jen pro praci s typek kusovniku "nizsi"
   my $sth_nizsi=$dbh->prepare(q{
      select
         Kusovnik.*
      from
         Zakazky.Kusovnik
      where
         Kusovnik.zakv=? and
         Kusovnik.platdo>=?
   });
   # zjistuje zda je zak sestavou
   my $sth_sestava=$dbh->prepare(q{
      select
         Kusovnik.zakn
      from
         Zakazky.Kusovnik
      where
         Kusovnik.zakv=? and
         Kusovnik.platdo>=?
      limit
         1
   });
   $sth_nizsi->execute($$vazba{zak},My->historie);
   while(my $ref_nizsi=$sth_nizsi->fetchrow_hashref) {
      # zjisteni informaci o zakazce
      my $datum=get_env("datum");
      if(!($$ref_nizsi{platod} le get_env("datum") and $$ref_nizsi{platdo} ge get_env("datum"))) { # jen u jiz neplatnych zaznamu posouvam datum
         set_env("datum",$$ref_nizsi{platdo});
      }
      my $infozak=$$vazba{_infozak};
      $$infozak{$$ref_nizsi{zakn}}=Info->zak($$ref_nizsi{zakn});
      set_env("datum",$datum);
      # ulozeni kusovnikove vazby
      my $kusovnik=$$vazba{_kusovnik};
      if($$vazba{_kuskmorg} eq "" or ($$infozak{$$ref_nizsi{zakn}}{kmorg} eq $$vazba{_kuskmorg} or ($$infozak{$$ref_nizsi{zakn}}{kmorg} eq "0" and $$infozak{$$vazba{zak}}{kmorg} eq $$vazba{_kuskmorg}))) {
         $$kusovnik{$$vazba{zak}}{$$ref_nizsi{zakn}}{$$ref_nizsi{platod}}{mnozc}=$$ref_nizsi{mnoz};
         $$kusovnik{$$vazba{zak}}{$$ref_nizsi{zakn}}{$$ref_nizsi{platod}}{ind}=$$ref_nizsi{ind};
         $$kusovnik{$$vazba{zak}}{$$ref_nizsi{zakn}}{$$ref_nizsi{platod}}{platdo}=$$ref_nizsi{platdo};
         $$kusovnik{$$vazba{zak}}{$$ref_nizsi{zakn}}{$$ref_nizsi{platod}}{pozice}=$$ref_nizsi{pozice};
         $$kusovnik{$$vazba{zak}}{$$ref_nizsi{zakn}}{$$ref_nizsi{platod}}{datzapis}=$$ref_nizsi{datzapis};
         $$kusovnik{$$vazba{zak}}{$$ref_nizsi{zakn}}{$$ref_nizsi{platod}}{uzivzapis}=$$ref_nizsi{uzivzapis};
         $sth_sestava->execute($$ref_nizsi{zakn},My->historie);
         if($sth_sestava->rows) {
            $$kusovnik{$$vazba{zak}}{$$ref_nizsi{zakn}}{$$ref_nizsi{platod}}{sestava}=1;
         }
      }
   }
   $sth_nizsi->finish;
}

#--  - ve fci probiha pripadna filtrace na pozadavek v $$vazba{_kuskmorg}
sub kusovnikvyssi {
   my ($pkg_p, $vazba)=@_;
   # dotaz jen pro praci s typek kusovniku "vyssi"
   my $sth_vyssi=$dbh->prepare(q{
      select
         Kusovnik.*
      from
         Zakazky.Kusovnik
      where
         Kusovnik.zakn=? and
         Kusovnik.platdo>=?
   });
   $sth_vyssi->execute($$vazba{zak},My->historie);
   while(my $ref_vyssi=$sth_vyssi->fetchrow_hashref) {
      # zjisteni informaci o zakazce
      my $datum=get_env("datum");
      if(!($$ref_vyssi{platod} le get_env("datum") and $$ref_vyssi{platdo} ge get_env("datum"))) { # jen u jiz neplatnych zaznamu posouvam datum
         set_env("datum",$$ref_vyssi{platdo});
      }
      my $infozak=$$vazba{_infozak};
      $$infozak{$$ref_vyssi{zakv}}=Info->zak($$ref_vyssi{zakv});
      set_env("datum",$datum);
      # ulozeni kusovnikove vazby
      my $kusovnik=$$vazba{_kusovnik};
      if($$vazba{_kuskmorg} eq "" or ($$infozak{$$ref_vyssi{zakv}}{kmorg} eq $$vazba{_kuskmorg})) {
         $$kusovnik{$$vazba{zak}}{$$ref_vyssi{zakv}}{$$ref_vyssi{platod}}{mnozc}=$$ref_vyssi{mnoz};
         $$kusovnik{$$vazba{zak}}{$$ref_vyssi{zakv}}{$$ref_vyssi{platod}}{ind}=$$ref_vyssi{ind};
         $$kusovnik{$$vazba{zak}}{$$ref_vyssi{zakv}}{$$ref_vyssi{platod}}{platdo}=$$ref_vyssi{platdo};
         $$kusovnik{$$vazba{zak}}{$$ref_vyssi{zakv}}{$$ref_vyssi{platod}}{pozice}=$$ref_vyssi{pozice};
         $$kusovnik{$$vazba{zak}}{$$ref_vyssi{zakv}}{$$ref_vyssi{platod}}{datzapis}=$$ref_vyssi{datzapis};
         $$kusovnik{$$vazba{zak}}{$$ref_vyssi{zakv}}{$$ref_vyssi{platod}}{uzivzapis}=$$ref_vyssi{uzivzapis};
         $$kusovnik{$$vazba{zak}}{$$ref_vyssi{zakv}}{$$ref_vyssi{platod}}{sestava}=1;
      }
   }
   $sth_vyssi->finish;
}

#--  - v teto funkci se nebere ohled na filtraci kmorg
sub kusovnikkde3738 {
   my ($pkg_p, $vazba)=@_;
   # pri zjistovani kam a kolik danne zakazky vstupuje uvazuji jen ty vazby, kde je indikace mensi ci rovna 1
   if($$vazba{ind}<=1) {
      # zjisteni informaci o zakazce
      my $infozak=$$vazba{_infozak};
      $$infozak{$$vazba{zakv}}=Info->zak($$vazba{zakv});
      # ulozeni kusovnikove vazby
      if($$infozak{$$vazba{zakv}}{ch} eq "37" or $$infozak{$$vazba{zakv}}{ch} eq "38") {
         my $kusovnik=$$vazba{_kusovnik};
         $$kusovnik{$$vazba{zak}}{$$vazba{zakv}}{sestava}=1;
         $$kusovnik{$$vazba{zak}}{$$vazba{zakv}}{mnozc}+=$$vazba{mnozc}; # musim pricitat, jelikoz pri jedinem rozpadu mohu v jine vetvi dojit k te same vazbe...
         $$kusovnik{$$vazba{zak}}{$$vazba{zakv}}{ind}=$$vazba{ind};
      }
      Kusovnik->invkusovnik($vazba);
   }
}

#--  - ve fci probiha pripadna filtrace na pozadavek v $$vazba{_kuskmorg}
sub kusovnikkonstr {
   my ($pkg_p, $vazba)=@_;
   # dotaz jen pro praci s typek kusovniku "nizsi"
   my $sth_nizsi=$dbh->prepare(q{
      select
         Kusovnik.*
      from
         Zakazky.Kusovnik
      where
         Kusovnik.zakv=? and
         Kusovnik.platod<=? and
         Kusovnik.platdo>=?
   });
   # zjistuje zda je zak sestavou
   my $sth_sestava=$dbh->prepare(q{
      select
         Kusovnik.zakn
      from
         Zakazky.Kusovnik
      where
         Kusovnik.zakv=? and
         Kusovnik.platod<=? and
         Kusovnik.platdo>=?
   });
   $sth_nizsi->execute($$vazba{zak},get_env("datum"),get_env("datum"));
   while(my $ref_nizsi=$sth_nizsi->fetchrow_hashref) {
      my $infozak=$$vazba{_infozak};
      $$infozak{$$ref_nizsi{zakn}}=Info->zak($$ref_nizsi{zakn});
      # ulozeni kusovnikove vazby
      my $kusovnik=$$vazba{_kusovnik};
      if($$vazba{_kuskmorg} eq "" or ($$infozak{$$ref_nizsi{zakn}}{kmorg} eq $$vazba{_kuskmorg} or ($$infozak{$$ref_nizsi{zakn}}{kmorg} eq "0" and $$infozak{$$vazba{zak}}{kmorg} eq $$vazba{_kuskmorg}))) {
         $$kusovnik{$$vazba{zak}}{$$ref_nizsi{zakn}}{mnozc}=$$ref_nizsi{mnoz};
         $$kusovnik{$$vazba{zak}}{$$ref_nizsi{zakn}}{ind}=$$ref_nizsi{ind};
         $$kusovnik{$$vazba{zak}}{$$ref_nizsi{zakn}}{pozice}=$$ref_nizsi{pozice};
         $$kusovnik{$$vazba{zak}}{$$ref_nizsi{zakn}}{pozn}=$$ref_nizsi{pozn};
         $sth_sestava->execute($$ref_nizsi{zakn},get_env("datum"),get_env("datum"));
         if($sth_sestava->rows) {
            $$kusovnik{$$vazba{zak}}{$$ref_nizsi{zakn}}{sestava}=1;
         }
      }
   }
   $sth_nizsi->finish;
}

#==
sub append_kusovniklist {
   my ($pkg_p, $rows,$opt,$zakv,$kusovnik,$infozak,$indc,$kmorgS,$doplnky,$souhrny)=@_;
   my $existfiltr;
   foreach my $zakn (sort keys %{$$kusovnik{$zakv}}) {
      my %souhrny=%{$souhrny}; # nektere souhrny je temer nutne delat az zde (pamatovak v klici zakv,zakn je nedostacujici, jelikoz ke stejnym vazbam se mohlo dojit v jine vetvi uplne jinou cestou...) a vyuzivat rekurzivniho postaveni pri tisku - pro kazde zakn se to stava lokalni promennou, kterou potom sledy nize po vnoreni neovlivnuji (tedy po navratu z rekurze tu mame puvodni hodnotu)
      my $style="";
      my $info_zak=$$infozak{$zakn};
      my $row=$rows->aT("row",{chosen=>"0"});
      my $indcn;
      if($$kusovnik{$zakv}{$zakn}{ind}>$indc) {
         $indcn=$$kusovnik{$zakv}{$zakn}{ind};
      }
      else {
         $indcn=$indc;
      }
      my $href=Link->zak($zakn); 
      my ($prvniO,$druhyO);
      $prvniO=$row->aT("col",{href=>$href,class=>"kusZak"},$zakn);
      $druhyO=$row->aT("col",{class=>"kusNazev"},$$info_zak{nazev});
      my $title= $$ch{$$info_zak{ch}} . "\n" . "kmorg: " . $$info_zak{kmorg} . "\n" . "vykrorg: " . $$info_zak{vykrorg};
      $row->aT("col",{style=>"color:green;",title=>$title},"(".$$info_zak{ch}."/".$$info_zak{kmorg}."/".$$info_zak{vykrorg}.")");
      $row->aT("col",{},$pkg->mnozmj($$kusovnik{$zakv}{$zakn}{mnoz},$$info_zak{mj}));
      if(defined($$kusovnik{$zakv}{$zakn}{mnozc})) {
         my $mjc;
         if($$opt{kustyp} eq "kde") {
            $mjc=$$infozak{$$opt{zak}}->{mj};
         }
         $row->aT("col",{style=>"color:blue;"},$pkg->mnozmj($$kusovnik{$zakv}{$zakn}{mnozc},$mjc));
      }
      else {
         $row->aT("col");
      }
      # Doplnky
      # - stav
      if($$doplnky{kusDstav}) {
         my $col=$row->aT("col",{style=>"color:blue;",title=>"stav: kmorg + vykrorg"});
         $col->aT(undef,{},"( ".$$info_zak{stav}{kmorg});
         if(defined($$info_zak{stav}{vykrorg})) {
            $col->aT(undef,{}," + ".$$info_zak{stav}{vykrorg});
         }
         $col->aT(undef,{}," )");
      }
      # - prubezna doba nebo normativ
      if($$doplnky{kusDpd} or $$doplnky{kusDnorm}) {
         if($$kusovnik{$zakv}{$zakn}{sled}>0) {
            $souhrny{pd}+=$$kusovnik{$zakv}{$zakn}{pd};
         }
         my $norm=$$kusovnik{$zakv}{$zakn}{norm};
         if(!defined($norm)) {
            $norm="prbn doba: zak / celkov";
         }
         my $col=$row->aT("col",{style=>"color:magenta;",title=>$norm});
         $col->aT(undef,{},"( ".(1*$$kusovnik{$zakv}{$zakn}{pd}));
         $col->aT(undef,{}," / ".(1*$souhrny{pd}));
         if(defined($$kusovnik{$zakv}{$zakn}{norm})) {
            $col->aT(undef,{}," *");
         }
         $col->aT(undef,{}," )");
      }
      # - tv
      if($$doplnky{kusDtv}) {
         my $col=$row->aT("col",{style=>"color:blue;",title=>"tV: samotn zak / celkem se vstupujcmi zak"});
         $col->aT(undef,{},"( ");
         if(defined($$kusovnik{$zakv}{$zakn}{tv})) {
            $col->aT(undef,{},sprintf("%.2f",$$kusovnik{$zakv}{$zakn}{tv}));
            $col->aT(undef,{}," / ");
            $col->aT(undef,{},sprintf("%.2f",$$kusovnik{$zakv}{$zakn}{tv}+$$kusovnik{_souhrny}{$zakn}{tv}));
            $col->aT(undef,{}," min");
         }
         $col->aT(undef,{}," )");
      }
      # - UVN
      if($$doplnky{kusDuvn}) {
         my $col=$row->aT("col",{style=>"color:blue;",title=>"VN: pidan hodnota / celkem"});
         $col->aT(undef,{},"( ");
         if(defined($$kusovnik{$zakv}{$zakn}{uvn})) {
            $col->aT(undef,{},sprintf("%.2f",$$kusovnik{$zakv}{$zakn}{uvnpridana}));
            $col->aT(undef,{}," / ");
            $col->aT(undef,{},sprintf("%.2f",$$kusovnik{$zakv}{$zakn}{uvn}));
            $col->aT(undef,{}," K");
         }
         $col->aT(undef,{}," )");
      }
      if(defined($$kusovnik{$zakn})) {
         my $rowsnew;
         if($$kusovnik{$zakv}{$zakn}{sled}==0) {
            $rowsnew=$rows->aT("rows",{open=>"2"});
         }
         else {
            $rowsnew=$rows->aT("rows");
         }
         if(
            $pkg->append_kusovniklist(
               $rowsnew,
               $opt,
               $zakn,
               $kusovnik,
               $infozak,
               $indcn,
               $$info_zak{kmorg},
               $doplnky,
               \%souhrny
               
            )
         ) {
            $existfiltr=1;
            $style="color:green;";
         }
      }
      if($indcn>1) {
         $style="color:gray;";
         $druhyO->sA("style",$style);
      }
      elsif($$info_zak{kmorg} eq $$doplnky{kuskmorg}) {
         $style="color:blue;";
         $existfiltr=1;
      }
      elsif($$info_zak{kmorg} eq "0" and $kmorgS eq $$doplnky{kuskmorg}) {
         $style="color:blue;";
         $existfiltr=1;
      }
      $prvniO->sA("style",$style);
   }
   return $existfiltr;
}
#==
sub append_kusovniktable {
   my ($pkg_p, $rows,$opt,$zakv,$kusovnik,$infozak,$idcs, $doplnkytable)=@_; # poznmaka pokud vim tak nyni je $doplnytable uzito jen u rozdiloveho kusovniku
   foreach my $zakn (sort keys %{$$kusovnik{$zakv}}) {
      if(defined($$kusovnik{$zakv}{$zakn}{ind})) {
         my $info_zak=$$infozak{$zakn};
         my $title=$$ch{$$info_zak{ch}};
         my $row=$rows->aT("row",{chosen=>"0"});
         my $style="";
         if($$kusovnik{$zakv}{$zakn}{ind}>1) {
            $style="color:gray;";
         }
         if($$kusovnik{$zakv}{$zakn}{sestava}) {
            my $href= My->okruh . '?_idcs=' . encode_uri($idcs) . '&zak=' . encode_uri($zakn);
            my $tag;
            $tag=$row->aT("col",{href=>$href});
            $tag=$tag->aT("xhtml");
            $tag=$tag->aT("img",{src=>"/share/icons/folder.gif",alt=>"+",border=>"0"});
         }
         else {
            my $tag;
            $tag=$row->aT("col");
            $tag=$tag->aT("xhtml");
            $tag=$tag->aT("img",{src=>"/share/icons/item.gif",alt=>""});
         }
         my $href=Link->zak($zakn);
         $row->aT("col",{href=>$href},$zakn);
         $row->aT("col",{style=>$style},$$info_zak{nazev});
         $row->aT("col",{style=>"color:green;",title=>$title},$$info_zak{ch});
         $row->aT("col",{style=>"color:green;"},$$info_zak{kmorg});
         $row->aT("col",{style=>"color:blue;"},$$info_zak{vykrorg});
         my $mjc;
         if($$opt{kustyp} eq "kde3738") {
            $mjc=$$infozak{$$opt{zak}}->{mj};
         }
         else {
            $mjc=$$infozak{$zakn}->{mj};
         }
         $row->aT("col",{},$pkg->mnozmj($$kusovnik{$zakv}{$zakn}{mnozc},$mjc));
         foreach my $colname (@{$doplnkytable}) {
            if($colname=~/^mnozc/) {
               my $mjc;
               if($$opt{kustyp} eq "kde3738") {
                  $mjc=$$infozak{$$opt{zak}}->{mj};
               }
               else {
                  $mjc=$$infozak{$zakn}->{mj};
               }
               $row->aT("col",{},$pkg->mnozmj($$kusovnik{$zakv}{$zakn}{$colname},$mjc));
            }
            else {
               $row->aT("col",{},$$kusovnik{$zakv}{$zakn}{$colname});
            }
         }
      }
   }
}
#==
sub append_kusovniktable_konstr {
   my ($pkg_p, $rows,$opt,$zakv,$kusovnik,$infozak,$idcs)=@_;
   my $zaknsorth;
   foreach my $zakn (keys %{$$kusovnik{$zakv}}) {
      my $pozicesort=$$kusovnik{$zakv}{$zakn}{pozice};
      # nize predpokladam, ze dimenze pozice v tabulce je maximalne 10 (pri psani tohoto kodu byla 6) - jde o abecedni razeni, ale hodnoty pozice doplnuji vlevo 0, takze pokud pozice obsahuje jen cisla bude vlastne razeni numericke
      $pozicesort= ("0" x (10-length($pozicesort))) . $pozicesort;
      $$zaknsorth{$pozicesort}{$zakn}=1;
   }
   my @zaknsorta;
   foreach my $pozice (sort keys %{$zaknsorth}) {
      foreach my $zakn (sort keys %{$$zaknsorth{$pozice}}) {
         push(@zaknsorta,$zakn);
      }
   }
   foreach my $zakn (@zaknsorta) {
      my $info_zak=$$infozak{$zakn};
      my $row=$rows->aT("row",{chosen=>"0"});
      my $style="";
      if($$kusovnik{$zakv}{$zakn}{ind}>1) {
         $style="color:gray;";
      }
      my $stylepoz="";
      if($$kusovnik{$zakv}{$zakn}{sestava}) {
         $stylepoz="font-weight: bold;";
      }
      $row->aT("col",{style=>$stylepoz},$$kusovnik{$zakv}{$zakn}{pozice});
      my $href=Link->zak($zakn);
      $row->aT("col",{href=>$href},$zakn);
      $row->aT("col",{style=>$style},$$info_zak{nazev});
      $row->aT("col",{style=>"color:green;"},$$info_zak{kmorg});
      $row->aT("col",{style=>"color:blue;"},$$info_zak{vykrorg});
      my $mjc=$$infozak{$zakn}->{mj};
      $row->aT("col",{},$pkg->mnozmj($$kusovnik{$zakv}{$zakn}{mnozc},$mjc));
      $row->aT("col",{},$$info_zak{format});
      $row->aT("col",{},$$kusovnik{$zakv}{$zakn}{pozn});
   }
}
#==
sub append_kusovniktable_platnost {
   my ($pkg_p, $rows,$opt,$zakv,$kusovnik,$infozak,$idcs)=@_;
   foreach my $zakn (sort keys %{$$kusovnik{$zakv}}) {
      foreach my $platod (sort keys %{$$kusovnik{$zakv}{$zakn}}) {
         if(defined($$kusovnik{$zakv}{$zakn}{$platod}{ind})) {
            my $info_zak=$$infozak{$zakn};
            my $title=$$ch{$$info_zak{ch}};
            my $row=$rows->aT("row",{chosen=>"0"});
            my $style="";
            if($$kusovnik{$zakv}{$zakn}{$platod}{ind}>1) {
               $style="color:gray;";
            }
            my $styleplat="";
            if(!($platod le get_env("datum") and $$kusovnik{$zakv}{$zakn}{$platod}{platdo} ge get_env("datum"))) {
               $styleplat="color:magenta;";
            }
            if($$kusovnik{$zakv}{$zakn}{$platod}{sestava}) {
               my $href= My->okruh . '?_idcs=' . encode_uri($idcs) . '&zak=' . encode_uri($zakn);
               my $tag;
               $tag=$row->aT("col",{href=>$href});
               $tag=$tag->aT("xhtml");
               $tag=$tag->aT("img",{src=>"/share/icons/folder.gif",alt=>"+",border=>"0"});
            }
            else {
               my $tag;
               $tag=$row->aT("col");
               $tag=$tag->aT("xhtml");
               $tag=$tag->aT("img",{src=>"/share/icons/item.gif",alt=>""});
            }
            my $href=Link->zak($zakn);
            $row->aT("col",{href=>$href},$zakn);
            $row->aT("col",{style=>$style},$$info_zak{nazev});
            $row->aT("col",{style=>"color:green;",title=>$title},$$info_zak{ch});
            $row->aT("col",{style=>"color:green;"},$$info_zak{kmorg});
            $row->aT("col",{style=>"color:blue;"},$$info_zak{vykrorg});
            $row->aT("col",{style=>$styleplat},$platod);
            $row->aT("col",{style=>$styleplat},$$kusovnik{$zakv}{$zakn}{$platod}{platdo});
            $row->aT("col",{},$$kusovnik{$zakv}{$zakn}{$platod}{ind});
            my $mjc;
            if($$opt{kustyp} eq "vyssi") {
               $mjc=$$infozak{$$opt{zak}}->{mj};
            }
            else {
               $mjc=$$infozak{$zakn}->{mj};
            }
            $row->aT("col",{},$pkg->mnozmj($$kusovnik{$zakv}{$zakn}{$platod}{mnozc},$mjc));
            $row->aT("col",{},$$kusovnik{$zakv}{$zakn}{$platod}{pozice});
            $row->aT("col",{},$$kusovnik{$zakv}{$zakn}{$platod}{datzapis});
            $row->aT("col",{},$$kusovnik{$zakv}{$zakn}{$platod}{uzivzapis});
         }
      }
   }
}



#=== Pomocne funkce
#- funkce urcujici org na zaklade predchoziho sledu - dulezite pro zakazky s kmorg (ci vykrorg) "0"
sub org {
   my ($pkg_p, $typorg,$vazba,$infozak)=@_;
   my $org;
   if($$infozak{$$vazba{zakn}}{$typorg} ne "0") {
     if($org ne $$infozak{$$vazba{zakn}}{$typorg}) {
        $org=$$infozak{$$vazba{zakn}}{$typorg};
     }
     else {
        $org=undef;
     }
   }
   else {
      if($org ne $$infozak{$$vazba{zakv}}{$typorg}) {
         $org=$$infozak{$$vazba{zakv}}{$typorg};
      }
      else {
         $org=undef;
      }
   }
   return $org;
}

#- funkce urcujici org na zaklade predchoziho sledu - dulezite pro zakazky s kmorg (ci vykrorg), ktere nejsou v holdingu ci jsou v holdingu, ale nemaji normy (a tim padem post. soucty)
sub orgholding {
   my ($pkg_p, $typorg,$vazba,$infozak)=@_;
   my $org;
   my $info_org=Info->org($$infozak{$$vazba{zakn}}{$typorg});
   if($$info_org{vcorg}) {
     if($org ne $$infozak{$$vazba{zakn}}{$typorg}) {
        $org=$$infozak{$$vazba{zakn}}{$typorg};
     }
     else {
        $org=undef;
     }
   }
   else {
      my $info_orgv=Info->org($$infozak{$$vazba{zakv}}{$typorg});
      if($org ne $$infozak{$$vazba{zakv}}{$typorg} and $$info_orgv{vcorg}) {
         $org=$$infozak{$$vazba{zakv}}{$typorg};
      }
      else {
         $org=undef;
      }
   }
   return $org;
}

#- funkce vraci naformatovane mnozstvi i s jednotkou
sub mnozmj {
   my ($pkg_p, $mnoz,$mj)=@_;
   my $text;
   if(length($mnoz)) {
      if($mj eq "60" and $mnoz==int($mnoz)) {
         $text.=sprintf("%.0f",$mnoz);
      }
      else {
         $text.=sprintf("%.3f",$mnoz);
      }
      if(length($mj)) {
         $text.=" ";
         $text.=Info->mj($mj)->{nazev};
      }
   }
   return $text;
}

return 1;

