package Spolecnost_orgsch;

# Knihovna slouzi k zobrazovani organizacniho schematu

my $pkg="Spolecnost_orgsch";

use strict;
use lib ("/home/web-mycompany/www/lib");
use My;
use MyXML;
use Link;
use Output;
use Info;


#==== Globalni promena tohohle balicku


#==== Napojeni na DB
my $dbh=My->dbh;


#==== Vystupni funkce ====#
sub zoborgsch {
   my ($pkg_p, $polozky,$idcs,$outputdev)=@_;
   # urceni strediska od ktereho zacnu rozpad
   my $sth_prvnistr=$dbh->prepare(q{
      select
         Str.str
      from
         Spolecnost.Str
      where
         Str.platod<=? and
         Str.platdo>=? and
         Str.org=?
      order by
         Str.str asc
      limit
         1
   });
   $sth_prvnistr->execute(get_env("datum"),get_env("datum"),get_env("org"));
   my $ref_prvnistr=$sth_prvnistr->fetchrow_hashref;
   $sth_prvnistr->finish;
   my $str=$$ref_prvnistr{str};
   # vytvareni vystupu
   $$outputdev{bezpre}=1;
   # vytvoreni html dokumentu
   my ($docO,$htmlO,$bodyO);
   ($docO,$htmlO,$bodyO,$$outputdev{prvniradek})=MyXML->creahtml($outputdev,$idcs);
   my $outputvar=[["Platnost:",get_env("datum")],["Zobrazit:",Spolecnost_orgsch->zobtypmenu->[$$polozky{zobtyp}{value}][1]]];
   $$outputdev{prvniradek}=Output->outputvar($bodyO,$outputvar,$outputdev);
   #======= TABLULKY ========#
   # vytvoreni xml dokumentu i s korenem table
   my ($docI,$table,$cols,$rows)=MyXML->creatable;
   # popis sloupcu
   $cols->aT("col",{},"St / O");
   $cols->aT("col",{},"Nzev (poet ednk + poet dlnk) / Jmno a funkce");
   #$cols->aT("col",{},"poet");
   #$cols->aT("col",{},"poet celkem");
   # zjisteni schematu
   $pkg->orgsch(
      {
         str => $str,
         sled => 0,
         rows => $rows,
         info => Info->str($str),
         _zobtyp => $$polozky{zobtyp}{value}
      }
   );
   # vystup
   $$outputdev{prvniradek}=Output->output(
      $bodyO,
      $table,
      $outputdev,
      "list"
   );
   #======= odeslani vystupu na vyst zarizeni
   # vlozeni informaci o zadanych parametrech
   Output->outputprint($docO,$outputdev);
}

#==
sub orgsch {
   my ($pkg_p, $vazba)=@_;
   my $info=$$vazba{info};
   my $row=$$vazba{rows}->aT("row",{chosen=>"0"});
   my $href=Link->str($$info{str}); 
   $row->aT("col",{href=>$href,style=>"color: blue;"},$$info{str});
   my $colO=$row->aT("col");
   my $xhtmlO_nazevstr=$colO->aT("xhtml");
   $xhtmlO_nazevstr->aT("b",{},$$info{nazev});
   if(length($$info{vyrtyp})) {
      $xhtmlO_nazevstr->aT(undef,{}," - ");
      $xhtmlO_nazevstr->aT("i",{},$$info{vyrtyp});
   }
   my $rows;
   $rows=$$vazba{rows}->aT("rows");
   if($$vazba{sled}==0) {
      $rows->sA("open","1");
   }
   if($$vazba{_zobtyp} eq "1") {
      my $sth_zam=$dbh->prepare(q{
         select
            Zamestnanci_zamestnani.oc
         from
            Zamestnanci.Zamestnanci_zamestnani
            inner join Zamestnanci.Zamestnanci on (Zamestnanci_zamestnani.oc=Zamestnanci.oc)
         where
            Zamestnanci_zamestnani.str=? and
            Zamestnanci_zamestnani.stavzam!="N" and
            Zamestnanci_zamestnani.platod<=? and
            Zamestnanci_zamestnani.platdo>=? and
            Zamestnanci.platod<=? and
            Zamestnanci.platdo>=?
         order by
            substring(Zamestnanci_zamestnani.typzam,2,1) desc,
            Zamestnanci.prijmeni asc,
            Zamestnanci.jmeno asc,
            Zamestnanci_zamestnani.stavzam asc,
            Zamestnanci_zamestnani.oc asc
      });
      my $color_typzam={
         D => "#697fff",
         T => "gray"
      };
      my $summary;
      $sth_zam->execute($$info{str},get_env("datum"),get_env("datum"),get_env("datum"),get_env("datum"));
      while(my $ref_zam=$sth_zam->fetchrow_hashref) {
         my $info_oc=Info->oc($$ref_zam{oc},{ zamfce=>1 });
         my $href=Link->oc($$info_oc{oc}); 
         my $row=$rows->aT("row",{chosen=>"0"});
         $row->aT("col",{href=>$href,class=>"kusZak"},$$info_oc{oc});
         my $colO=$row->aT("col");
         my $xhtmlO=$colO->aT("xhtml");
         $xhtmlO->aT(undef,{},$$info_oc{jmeno} . " " . $$info_oc{prijmeni});
         $xhtmlO->aT(undef,{}," - ");
         $xhtmlO->aT("i",{},$$info_oc{funkce_nazev});
         $xhtmlO->aT(undef,{},", ");
         my $iO=$xhtmlO->aT("i",{},$$info_oc{typzam});
         if($$info_oc{typzam}=~/^.D.$/) {
            ++$$summary{pocet_delniku};
            $iO->sA("style","color: ".$$color_typzam{D}.";");
         }
         else {
            ++$$summary{pocet_uredniku};
            $iO->sA("style","color: ".$$color_typzam{T}.";");
         }
      }
      $sth_zam->finish;
      # doplneni poctu zamestnancu v zavorce za nazev strediska
      my $spanO=$xhtmlO_nazevstr->aT("span",{title=>"(poet ednk + poet dlnk)"});
      $spanO->aT(undef,{}," (");
      $spanO->aT("span",{style=>"color: ".$$color_typzam{T}.";"},1*$$summary{pocet_uredniku});
      $spanO->aT(undef,{},"+");
      $spanO->aT("span",{style=>"color: ".$$color_typzam{D}.";"},1*$$summary{pocet_delniku});
      $spanO->aT(undef,{},")");
   }
   elsif($$vazba{_zobtyp} eq "2") {
      my $info_prac=Info->prac($$info{str});
      foreach my $prac (sort keys %{$info_prac}) {
         my $row=$rows->aT("row",{chosen=>"0"});
         $row->aT("col",{class=>"kusZak"},$prac);
         my $colO=$row->aT("col");
         my $xhtmlO=$colO->aT("xhtml");
         $xhtmlO->aT(undef,{},$$info_prac{$prac}{nazev});
         $xhtmlO->aT("span", { style => "color: green;" }, " (" . $$info_prac{$prac}{pocet} .")" );
         if(length($$info_prac{$prac}{skup})) {
            $xhtmlO->aT(undef,{}," - ");
            $xhtmlO->aT("i",{},$$info_prac{$prac}{skup});
         }
      }
   }
   # zjisteni podstredisek
   my $sth_str=$dbh->prepare(q{
      select
         Str.str
      from
         Spolecnost.Str
      where
         Str.platod<=? and
         Str.platdo>=? and
         Str.org=? and
         Str.supstr=?
      order by
         Str.str asc
   });
   $sth_str->execute(get_env("datum"),get_env("datum"),get_env("org"),$$vazba{str});
   while(my $ref_str=$sth_str->fetchrow_hashref) {
      $pkg->orgsch(
         {
            str => $$ref_str{str},
            sled => $$vazba{sled}+1,
            rows => $rows,
            info => Info->str($$ref_str{str}),
            _zobtyp => $$vazba{_zobtyp}
         }
      );
   }
   $sth_str->finish;
}

#==== Pomocne funkce ====#
sub zobtypmenu {
   return [["0","jen st"],["1","zamstnance"],["2","pracovit"]];
}

return 1;

