package Vnitr_ceny_vyp;

my $pkg="Vnitr_ceny_vyp";

use strict;
use My;
use Conversion;
use Info;
use Vyroba_priprava;
use Kusovnik;
use Vnitr_ceny;


#==== Globalni promena tohohle balicku
# poradi je dulezite - pouzivas ho pri zapisu !!!!
my @naklady=("mat","koop","mzda","opn1","opn2","vyrrez","sprrez");
# dalsi promenne plnene behem vypoctu - POZOR pokud v ramci jednoho programu nejake funkce opakujes, bude mozna treba prislusne promenne nulovat
my $vnitr_ceny;
my %vnitr_ceny_posloper;
my %vnitr_ceny_znupl;
my $vnitr_ceny_sumzakn;

#==== Napojeni na DB
my $dbh=My->dbh;
# priprava nekterych dotazu
my $sth_reziezak=$dbh->prepare(q{
   select
      Rezie_zak.naradi
   from
      Zakazky.Rezie_zak
   where
      Rezie_zak.zak=? and
      Rezie_zak.platod<=? and
      Rezie_zak.platdo>=?
});
my $sth_vykon=$dbh->prepare(q{
   select
      Vykon_norma.oper,
      Vykon_norma.str,
      Vykon_norma.tta,
      Vykon_norma.tamin,
      Vykon_norma.tvmin
   from
      Vyroba_priprava.Vykon_norma
   where
      Vykon_norma.zak=? and
      Vykon_norma.platod<=? and
      Vykon_norma.platdo>=? and
      Vykon_norma.ind<=?
});
my $sth_vykonkoop=$dbh->prepare(q{
   select
      Vykon_norma.oper,
      Vykon_norma.str,
      Vykon_norma.tta,
      Vykon_norma.tamin,
      Vykon_norma.tvmin
   from
      Vyroba_priprava.Vykon_norma
   where
      Vykon_norma.zak=? and
      Vykon_norma.platod<=? and
      Vykon_norma.platdo>=? and
      Vykon_norma.ind<=? and
      Vykon_norma.oper>=? and
      Vykon_norma.oper<=?
});
my $sth_normativ=$dbh->prepare(q{
   select
      Normativy.zak
   from
      Vyroba_planovani.Normativy
   where
      Normativy.zak=? and
      Normativy.platod<=? and
      Normativy.platdo>=?
   limit
      1
});
my $sth_mat=$dbh->prepare(q{
   select
      Material_norma.mat,
      Material_norma.oper,
      Material_norma.mj,
      Material_norma.mnoz
   from
      Vyroba_priprava.Material_norma
   where
      Material_norma.zak=? and
      Material_norma.platod<=? and
      Material_norma.platdo>=? and
      Material_norma.ind<=?
});
my $sth_mat_uplnostmatnor=$dbh->prepare(q{
   select
      Material_norma.mat
   from
      Vyroba_priprava.Material_norma
   where
      Material_norma.zak=? and
      Material_norma.platod<=? and
      Material_norma.platdo>=? and
      Material_norma.oper="000"
   limit
      1
});
my $sth_matcis=$dbh->prepare(q{
   select
      Material.mj,
      Material.kmorg
   from
      Material.Material
   where
      Material.mat=? and
      Material.platod<=? and
      Material.platdo>=?
});
my $sth_matcenik=$dbh->prepare(q{
   select
      Material_cenik.cena,
      Material_cenik.prir
   from
      Material.Material_cenik
   where
      Material_cenik.mat=? and
      Material_cenik.platod<=? and
      Material_cenik.platdo>=?
});
my $sth_koop=$dbh->prepare(q{
   select
      Kooperace_cenik.zak,
      Kooperace_cenik.odoper,
      Kooperace_cenik.dooper,
      Kooperace_cenik.cena
   from
      Vyroba_priprava.Kooperace_cenik
   where
      Kooperace_cenik.zak like ? and
      Kooperace_cenik.platod<=? and
      Kooperace_cenik.platdo>=?
   order by
      Kooperace_cenik.odoper asc
});
my $sth_zakcenik=$dbh->prepare(q{
   select
      Zakazky_cenik.cena
   from
      Zakazky.Zakazky_cenik
   where
      Zakazky_cenik.zak=? and
      Zakazky_cenik.platod<=? and
      Zakazky_cenik.platdo>=?
});
my $sth_zakschval=$dbh->prepare(q{
   select
      Zakazky_schval.datschval
   from
      Zakazky.Zakazky_schval
   where
      Zakazky_schval.zak=?
});


#===== POMOCNE FUNKCE URCUJICI ZPUSOB BEHU FCI V TETO KNIHOVNE
sub vnitr_ceny_tabulka {
   my $vnitr_ceny_tabulka;
   if(get_env("org") eq "0") {
      $vnitr_ceny_tabulka="Vyroba_ceny.Vnitr_ceny"; # !!! drive jsi holdingove vypocty zaznamenaval do tabulky Vyroba_ceny.Vnitr_ceny_holding, to nyni jiz nedelam, jelikoz predpokladam, ze vypocet je pro holdingove org JEN holdingovy a pro neholdingove org JEN neholdingovy !!!
   }
   else {
      $vnitr_ceny_tabulka="Vyroba_ceny.Vnitr_ceny";
   }
   return $vnitr_ceny_tabulka;
}


#===== FUNKCE ZJISTUJICI JIZ VYPOCTENA DATA Z DATABAZE A PRIPADNE UPRAVUJICI DATA PRED VYPOCTEM A TAKE ZAPISUJICI VYSLEDNA DATA PO VYPOCTU
# funkce nize jsou specificke tim, ze pracuji s tabulkou Vyroba_ceny.Vnitr_ceny a
# !!! funkce jsou uzivany (asi) jen fci "vypvc.phtml" !!!!
#- zjisteni, zda zak, ktera byla jiz vypoctena a oznacena za uplnou, nebyla dodatecne oznacena za neuplnou formou tvrde zadaneho data mluviciho o neuplnosti
#  - v takovem pripade je treba jeji udaje smazat i s udaji zakazek vyssich a spocist tohle vse znovu
sub del_vnitr_ceny_datneupl {
   # pokud jde o celoholdingovy pohled, tak neprovadim dodatecne zneuplnovani;
   # rekneme, ze to nevadi za predpokladu, ze pokud nekdo dodatecne
   # neuplnost vyvola, bude to v dobe, kdy jeste budou hold. post. soucty neuplne
   # ci nespoctene, pokud tomu tak nebude tak je to problem;
   # nyni to proste neresim (ten clovek by to delat nemel...)
   # !!! predpokladam uplny zanik teto zalezitosti !!!
   # !!! dodatecne zneuplnovani by melo prestat existovat !!!
   # predpokladam, ze k budoucimu zaniku nyni pomuze prave zmena vyznamu a
   # prace s datschval - nyni se jedna o schvaleni vyrobniho postupu,
   # ktere musi nekdo ucinit a existence data je tedy pro uplnost povina
   if(get_env("org") ne "0") {
      my $sth_datneuplnost=$dbh->prepare(q{
         select
            Zakazky_schval.zak
         from
            Zakazky.Zakazky_schval
         where
            Zakazky_schval.datschval>?
      });
      $sth_datneuplnost->execute(get_env("datum"));
      while(my $ref_datneuplnost=$sth_datneuplnost->fetchrow_hashref) {
         $pkg->del_vnitr_ceny(
            Kusovnik->invini({
               zak =>            $$ref_datneuplnost{zak},
               mnoz =>           1,
               _funkce =>        "$pkg->del_vnitr_ceny",
            })
         );
      }
      $sth_datneuplnost->finish;
   }
}
#- fce odstranujici udaje z promenne obsahujici vnitrni ceny (na zaklade oznaceni datem neuplnosti) (udaje budou nasledne spocteny znovu) (je trba odstranit udaje i u vsech polozek vyssich, aby byly spocteny znovu)
sub del_vnitr_ceny {
   my ($pkg_p, $vazba)=@_;
   my $sth_vnitr_ceny_del=$dbh->prepare(q{
      delete from
         } . $pkg->vnitr_ceny_tabulka . q{
      where
         org=? and
         rok=? and
         zak=?
   });
   $sth_vnitr_ceny_del->execute(get_env("org"),substr(get_env("datum"),0,4),$$vazba{zakv});
   Kusovnik->invkusovnik($vazba);
}

#- nacerpani hodnot polozek z jiz uzavrenych postupnych souctu Vnitr_ceny
# !!! pozor fce je uzita i pro cteni v ramci vypoctu u jedine zak
sub read_vnitr_ceny_uplne {
   my $sth_read=$dbh->prepare(q{
      select
         org,
         zak,
         oper,
         mat,
         koop,
         mzda,
         opn1,
         opn2,
         vyrrez,
         sprrez,
         datzapis,
         uzivzapis
      from
         } . $pkg->vnitr_ceny_tabulka . q{
      where
         org like ? and
         rok=? and
         posloper=? and
         znupl=?
   });
   # u celoholdingoveho pohledu nactu vse
   if(get_env("org") eq "0") {
      $sth_read->execute("%",substr(get_env("datum"),0,4),"*","0");
   }
   # u pohledu or nactu jen prislusnou org
   else {
      $sth_read->execute(get_env("org"),substr(get_env("datum"),0,4),"*","0");
   }
   while(my $ref_read=$sth_read->fetchrow_hashref) {
      $vnitr_ceny_posloper{$$ref_read{org}}{$$ref_read{zak}}=$$ref_read{oper}; # ctu vzdy jen posloper
      foreach my $naklad (@naklady) {
         $$vnitr_ceny{$$ref_read{org}}{$$ref_read{zak}}{$$ref_read{oper}}{$naklad}=$$ref_read{$naklad};
      }
      foreach my $col ("datzapis","uzivzapis") {
         $$vnitr_ceny{$$ref_read{org}}{$$ref_read{zak}}{$$ref_read{oper}}{$col}=$$ref_read{$col};
      }
      $$vnitr_ceny{$$ref_read{org}}{$$ref_read{zak}}{$$ref_read{oper}}{_read}=1; # delam si znacku, ze zaznam byl ziskat ctenim, abych ho pak pri zapise nezapisoval (stejne si pamatuji jen posledni operaci)
   }
   $sth_read->finish;
}

#- vypocet vnitrnich cen
sub calc_vnitr_ceny {
   # vypocet jen u zak, kde je dana org kmorg a zakazka zacina 0 nebo 1 a konci 0
   my $sth_zak;
   if(get_env("org") eq "0") {
      $sth_zak=$dbh->prepare(q{
         select
            Zakazky.zak
         from
            Zakazky.Zakazky
            inner join Spolecnost.Org on (Zakazky.kmorg=Org.org)
         where
            Org.vcorg="1" and
            Zakazky.zak regexp "^[01]"
      });
      $sth_zak->execute;
   }
   else {
      $sth_zak=$dbh->prepare(q{
         select
            Zakazky.zak
         from
            Zakazky.Zakazky
         where
            Zakazky.kmorg=? and
            Zakazky.zak regexp "^[01]"
      });
      $sth_zak->execute(get_env("org"));
   }
   while(my $ref_zak=$sth_zak->fetchrow_hashref) {
      $pkg->vnitr_ceny(
         Kusovnik->ini({
            zak =>         $$ref_zak{zak},  # 03928211103400
            mnoz =>        1,
            _funkce =>     "$pkg->vnitr_ceny",
            _indmax =>     1
         })
      );
   }
   $sth_zak->finish;
}

#- vypocet vnitrnich cen jen u jedne zadane zak (pokud je neuplna) a i provedeni vymazu predchozich udaju a zapisu novych
sub readcalcwrite_vnitr_ceny_zak {
   my ($pkg_p, $zakf)=@_;
   my $code;
   # napred musis zjistit zda je mozne u zadane zak vubec vypocet a zapis hodnot provest - musi splnovat urcita pravidla a ta musi korespondovat i s dalsimi funkcemi v teto knihovne uvedenymi a urcenymi pro hromadny vypocet vnitr. souctu
   my $ref_zakf=Info->zak($zakf);
   my $info_vnitr_ceny;
   if(get_env("org") eq "0") {
      # zjisteni informaci o kmorg - pozdeji mne zajima zda je holdingova ci ne
      my $info_kmorg=Info->org($$ref_zakf{kmorg});
      if($$info_kmorg{vcorg} eq "1") {
         set_env("org",$$ref_zakf{kmorg});
         $info_vnitr_ceny=Info->vnitr_ceny($zakf,"*");
         set_env("org","0");
      }
      else {
         # pokud je kmorg 0, tak to nemohu z pohledu holdingu pocitat a proto zde natvrdo zacnu tvrdit, ze je zak uplna (abych to pozdejc nepocital)
         $$info_vnitr_ceny{znupl}="0";
      }
   }
   else {
      $info_vnitr_ceny=Info->vnitr_ceny($zakf,"*");
   }
   if($$info_vnitr_ceny{znupl} ne "0" and $zakf=~/^[01]/) {
      $code=1;
      # read - trapne sice nacitam vse (asi by to slo zlepsit), ale musim, abych u sestav nepocital nejake dily, ktere jsou jiz uplne znovu - coz nesmim!!!
      $pkg->read_vnitr_ceny_uplne;
      # calc
      $pkg->vnitr_ceny(
         Kusovnik->ini({
            zak =>         $zakf,
            mnoz =>        1,
            _funkce =>     "$pkg->vnitr_ceny",
            _indmax =>     1
         })
      );
      # write
      $pkg->write_vnitr_ceny;
   }
   else {
      $code=-1;
   }
   return $code;
}

#- samotny zapis vypoctenych hodnot
# !!! pozor fce je uzita i pro zapis v ramci vypoctu u jedine zak
sub write_vnitr_ceny {
   # samotny zapis
   my $sth_replace=$dbh->prepare(q{
      replace
         } . $pkg->vnitr_ceny_tabulka . q{
      (
         org,
         rok,
         zak,
         posloper,
         oper,
         znupl,
         mat,
         koop,
         mzda,
         opn1,
         opn2,
         vyrrez,
         sprrez,
         datzapis,
         uzivzapis
      )
      values (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)
   });
   ## ZMENA 2003-05-05 - predtim jsi delal vymaz kompetne pred zapisem, ale myslim, ze byl nevyhovujici v pripade holdingoveho pohledu a take ne chvili mizeli vsechny neuplne postupne soucty (a to take mohlo vadit)
   # samotnemu zapisu predchazi vymaz neuplnych zaznamu (protoze v novem vypoctu nektere zaznamy jiz nemusi byt a tak nedoslo k jejich prepsani)
   my $sth_del=$dbh->prepare(q{
      delete from
         } . $pkg->vnitr_ceny_tabulka . q{
      where
         org=? and
         rok=? and
         zak=?
   });
   foreach my $vyporg (sort keys %{$vnitr_ceny}) {
      foreach my $zak (sort keys %{$$vnitr_ceny{$vyporg}}) {
         # zapis budu cinit jen u zaznmu nove vypoctenych - ne tedy u tech uplnych jeichz posledni operaci jsem jiz nacetl z databaze a ktere tam tedy jiz jsou zapsany
         if(!$$vnitr_ceny{$vyporg}{$zak}{$vnitr_ceny_posloper{$vyporg}{$zak}}{_read}) {
            $sth_del->execute($vyporg,substr(get_env("datum"),0,4),$zak);
            foreach my $oper (sort keys %{$$vnitr_ceny{$vyporg}{$zak}}) {
               my $bind=1;
               $sth_replace->bind_param($bind,$vyporg); ++$bind;
               $sth_replace->bind_param($bind,substr(get_env("datum"),0,4)); ++$bind;
               $sth_replace->bind_param($bind,$zak); ++$bind;
               if($vnitr_ceny_posloper{$vyporg}{$zak} eq $oper) {
                  $sth_replace->bind_param($bind,"*");
               }
               else {
                  $sth_replace->bind_param($bind,"");
               }
               ++$bind;
               $sth_replace->bind_param($bind,$oper); ++$bind;
               my $value=1*$vnitr_ceny_znupl{$vyporg}{$zak}{celkem};
               $sth_replace->bind_param($bind,$value); ++$bind;
               foreach my $naklad (@naklady) {
                  my $value=1*$$vnitr_ceny{$vyporg}{$zak}{$oper}{$naklad};
                  $sth_replace->bind_param($bind,$value);
                  ++$bind;
               }
               if(!defined($$vnitr_ceny{$vyporg}{$zak}{$oper}{datzapis})) { # v pripade nove spoctenych zaznamu jeste musis rici kdo vypocet spustil a kdy
                  $$vnitr_ceny{$vyporg}{$zak}{$oper}{datzapis}=My->datetime_now;
                  $$vnitr_ceny{$vyporg}{$zak}{$oper}{uzivzapis}=My->remote_user;
               }
               foreach my $col ("datzapis","uzivzapis") {
                  $sth_replace->bind_param($bind,$$vnitr_ceny{$vyporg}{$zak}{$oper}{$col});
                  ++$bind;
               }
               $sth_replace->execute;
            }
         }
      }
   }
}


#===== FUNKCE JEN PRO FCI ZOBRAZUJICI JAK JE TO AKTUALNE S POLOZKAMY ZADANEHO FINALU (ZADANE ZAK)
#- fce proste normalka spocte aktualne postupne soucty pro zadanou zak a i vsechny zak vstupujici
#  a nakonec proste jen vrati pointer na hash rikajici jak je to s uplnosti jednotlivych zak
sub calc_uplnost {
   my ($pkg_p, $zakf)=@_;
   my %uplnost;
   $pkg->vnitr_ceny(
      Kusovnik->ini({
         zak =>         $zakf,
         mnoz =>        1,
         _funkce =>     "$pkg->vnitr_ceny",
         _indmax =>     1
      })
   );
   foreach my $vyporg (keys %vnitr_ceny_znupl) {
      foreach my $zak (keys %{$vnitr_ceny_znupl{$vyporg}}) {
         if(length($zak)) {
            $uplnost{$vyporg}{$zak}=1*$vnitr_ceny_znupl{$vyporg}{$zak}{celkem};
         }
      }
   } 
   return \%uplnost;
}
#- fce proste normalka spocte aktualne postupne soucty ("operativni") pro zadanou zak a i vsechny zak vstupujici, zaznamena vsak jen ty na zadanou zak
sub calc_vnitr_ceny_operat {
   my ($pkg_p, $zakf)=@_;
   my $vnitr_ceny_operat;
   $pkg->vnitr_ceny(
      Kusovnik->ini({
         zak =>         $zakf,
         mnoz =>        1,
         _funkce =>     "$pkg->vnitr_ceny",
         _indmax =>     1
      })
   );
   my $ref_zakf=Info->zak($zakf);
   my @vyporg;
   if(get_env("org") eq "0") {
      push(@vyporg,$$ref_zakf{kmorg});
   }
   else {
      push(@vyporg,get_env("org"));
   }
   foreach my $vyporg (@vyporg) {
      foreach my $zak ($zakf) {
         foreach my $oper (sort keys %{$$vnitr_ceny{$vyporg}{$zak}}) {
            my $ref;
            $$ref{org}=$vyporg;
            $$ref{rok}=substr(get_env("datum"),0,4);
            $$ref{zak}=$zak;
            if($vnitr_ceny_posloper{$vyporg}{$zak} eq $oper) {
               $$ref{posloper}="*";
            }
            else {
               $$ref{posloper}="";
            }
            $$ref{oper}=$oper;
            $$ref{znupl}=1*$vnitr_ceny_znupl{$vyporg}{$zak}{celkem};
            foreach my $naklad (@naklady) {
               $$ref{$naklad}=1*$$vnitr_ceny{$vyporg}{$zak}{$oper}{$naklad};
            }
            $$ref{datzapis}=My->datetime_now;
            $$ref{uzivzapis}=My->remote_user;
            push(@{$vnitr_ceny_operat},$ref)
         }
      }
   } 
   return $vnitr_ceny_operat;
}


#===== HLAVNI VYPOCTOVE VYKONNE FUNKCE
#- hlavni funkce pocitajici vnitr_ceny
sub vnitr_ceny {
   my ($pkg_p, $vazba)=@_;
   # informace o zakazce nizsi a vyssi
   my $ref_zakn=Info->zak($$vazba{zakn});
   my $ref_zakv=Info->zak($$vazba{zakv});
   # kdyz je kmorg 0, tak tam napal tu kmorg ze zak vyssi
   if($$ref_zakn{kmorg} eq "0") {
      ## ZMENA 2003-03-04 - drive zde nebyla podminka, ale ciste jen radek "$$ref_zakn{kmorg}=$$ref_zakv{kmorg};", coz vychazelo z toho, ze k zakazkam s kmorg 0 dojdu jedine rozpadem kusovniku - nyni pocitam i s moznosti izolovaneho vyvolani zjisteni operativni ceny pro zakazku s kmorg "0", ale ma to jen smysl v nejakem konkretnim organizacnim pohledu
      if(length($$ref_zakv{kmorg}) and $$ref_zakv{kmorg} ne "0") {
         $$ref_zakn{kmorg}=$$ref_zakv{kmorg};
      }
      else {
         $$ref_zakn{kmorg}=get_env("org");
      }
   }
   # zjisteni informaci o kmorg - pozdeji mne zajima zda je holdingova ci ne
   my $info_kmorg=Info->org($$ref_zakn{kmorg});
   # zaznamenani vyporg ("vypoctove org") do vazby
   if(get_env("org") eq "0") {
      ## ZMENA 2002-12-18 - puvodne jsi zde vzdy prirazoval: $$vazba{vyporgn}=$$ref_zakn{kmorg};
      if($$info_kmorg{vcorg} eq "1") {
         $$vazba{vyporgn}=$$ref_zakn{kmorg};
      }
      else {
         $$vazba{vyporgn}=$$ref_zakv{kmorg};
      }
      $$vazba{vyporgv}=$$ref_zakv{kmorg};
   }
   else {
      $$vazba{vyporgn}=get_env("org");
      $$vazba{vyporgv}=get_env("org");
   }
   # zaznam prepoctene kmorg do vazby
   $$vazba{prepkmorg}=$$ref_zakn{kmorg};
   if(!defined($$vnitr_ceny{$$vazba{vyporgn}}{$$vazba{zakn}})) {
      # urceni jakou cestou vypoctu se pujde dal (interni ci externi? tedy pres normy ci mrknu do ceniku?)
      my $vypcesta;
      if(get_env("org") eq "0") {
         if($$info_kmorg{vcorg} eq "1") {
            $vypcesta="int";
         }
         else {
            $vypcesta="ext";
         }
      }
      else {
         if($$ref_zakn{kmorg} eq get_env("org")) {
            $vypcesta="int";
         }
         else {
            $vypcesta="ext";
         }
      }
      # zakazka je z aktualni org nebo z org 0
      if($vypcesta eq "int") {
         Kusovnik->kusovnik($vazba);
         my $vnitr_ceny_nekumul;
         # spocteni nakladu i s naklady ze spodku kusovniku, ktere mam ulozeny v glob promene $vnitr_ceny_sumzakn
         foreach my $naklad (@naklady) {
            $$vnitr_ceny_nekumul{"000"}{$naklad}=$$vnitr_ceny_sumzakn{$$vazba{vyporgn}}{$$vazba{zakn}}{$naklad};
         }
         $pkg->vnitr_cena_interni($vazba,$vnitr_ceny_nekumul);
         delete($$vnitr_ceny_sumzakn{$$vazba{vyporgn}}{$$vazba{zakn}}); # uz nebude potreba
         $pkg->sumznupl($vazba,$$ref_zakn{ch}); # zjisteni celkoveho znaku uplnosti
         $pkg->vnitr_ceny_sumzakn($vazba,\@naklady); # prihozeni nakladu na polozku nad (vyssi)
      }
      # zakazka je z jine nez aktualni org -> Zakazky_cenik cenu do mat
      else {
         # pozn: pod touto zakazakou z pohledu dane org jiz nic neni...
         $pkg->vnitr_cena_nakupovana($vazba);
         ## ZMENA 2003-05-05 - natvrdo zde nastavujes chrakteristiku na "02", jelikoz v teto vetvi programu se chces z hlediska zjistovani uplnosti k zakazce chovat jak k zakazce nakupovane
         $pkg->sumznupl($vazba,"02"); # zjisteni celkoveho znaku uplnosti
         $pkg->vnitr_ceny_sumzakn($vazba,["mat"]); # prihozeni nakladu na polozku nad (vyssi)
      }
   }
   else {
      $pkg->vnitr_ceny_sumzakn($vazba,\@naklady); # prihozeni nakladu na polozku nad (vyssi)
   }
}

# pomocna fce
sub vnitr_ceny_sumzakn {
   my ($pkg_p,$vazba,$naklady)=@_;
   my $posloper=$vnitr_ceny_posloper{$$vazba{vyporgn}}{$$vazba{zakn}};
   if(defined($posloper)) {
      foreach my $naklad (@{$naklady}) {
         $$vnitr_ceny_sumzakn{$$vazba{vyporgv}}{$$vazba{zakv}}{$naklad}+=$$vazba{mnoz}*$$vnitr_ceny{$$vazba{vyporgn}}{$$vazba{zakn}}{$posloper}{$naklad};  # mnoz - ne mnozc
      }
   }
   # pripadna uprava znupl polozky nad (vyssi)
   if($vnitr_ceny_znupl{$$vazba{vyporgn}}{$$vazba{zakn}}{celkem}>0) {
      $vnitr_ceny_znupl{$$vazba{vyporgv}}{$$vazba{zakv}}{"4"}=1;
   }
}
sub sumznupl {
   my ($pkg_p, $vazba,$ch)=@_;
   # zjisteni zda je zakazka kooperce ci ne
   my $kooperace;
   if($$vazba{zakn}=~/0$/) {
      $kooperace=0;
   }
   else {
      $kooperace=1;
   }
   # samotne zjistovani uplnosti
   if($vnitr_ceny_znupl{$$vazba{vyporgn}}{$$vazba{zakn}}{"1"} and $ch=~/^.[0-2]$/ and !$kooperace) { # 1 - material (netreba u sestav)
      $vnitr_ceny_znupl{$$vazba{vyporgn}}{$$vazba{zakn}}{celkem}+=1;
   }
   if($ch!~/^0/ and $ch ne "99") {
      if($vnitr_ceny_znupl{$$vazba{vyporgn}}{$$vazba{zakn}}{"2"}) { # 2 - vykon
         $vnitr_ceny_znupl{$$vazba{vyporgn}}{$$vazba{zakn}}{celkem}+=2;
      }
      ## ZMENA 2003-07-01 - jelikoz naradovna (org 5) nepise normativy, tak u jejich zakazek nyni nekontroluji zda normativy existuji
      if($vnitr_ceny_znupl{$$vazba{vyporgn}}{$$vazba{zakn}}{"16"} and !$kooperace and $$vazba{vyporgn} ne "5") { # 16 - normativ
         $vnitr_ceny_znupl{$$vazba{vyporgn}}{$$vazba{zakn}}{celkem}+=16;
      }
   }
   if($vnitr_ceny_znupl{$$vazba{vyporgn}}{$$vazba{zakn}}{"4"}) { # 4 - vstupujici polozka
      $vnitr_ceny_znupl{$$vazba{vyporgn}}{$$vazba{zakn}}{celkem}+=4;
   }
   ## ZMENA 2003-10-23 - schvaleny postup musi mit zakazky u kterych je take vyzadovana vykonova norma, ostatni ho svaleny mit nemusi (napriklad nakupovane polozky nemusi mit schvaleny postup)
   if($ch!~/^0/ and $ch ne "99") {
      ## ZMENA 2003-10-01 - zmena prace a vyznamu s datschval (nyni je vyznamem schvaleni vyrobniho postupu) (drive jsem s datem nepracoval na holdingove urovni, to se nyni meni)
      $sth_zakschval->execute($$vazba{zakn});
      my $ref_zakschval=$sth_zakschval->fetchrow_hashref;
      if(!defined($$ref_zakschval{datschval}) or $$ref_zakschval{datschval} gt get_env("datum")) { # 8 - z duvodu zadaneho ci nezadaneho data (vyznam posunut na neuplnost z duvodu neschvaleni vyrobniho postupu) mluviciho o neuplnosti
         $vnitr_ceny_znupl{$$vazba{vyporgn}}{$$vazba{zakn}}{celkem}+=8;
      }
      $sth_zakschval->finish;
   }
}

#- vypocet vnitr ceny u soucastek danne org
sub vnitr_cena_interni {
   my ($pkg_p, $vazba,$vnitr_ceny_nekumul)=@_; # v parametru $vnitr_ceny_nekumul je zde obsazen naklad ze soucastek v kusovniku pod danou zak
   # zjisteni cen na jeden kus
   $vnitr_ceny_nekumul=$pkg->vykon($$vazba{vyporgn},$$vazba{zakn},$vnitr_ceny_nekumul);
   $vnitr_ceny_nekumul=$pkg->normativ($$vazba{vyporgn},$$vazba{zakn},$vnitr_ceny_nekumul);
   $vnitr_ceny_nekumul=$pkg->mat($$vazba{vyporgn},$$vazba{zakn},$vnitr_ceny_nekumul);
   $vnitr_ceny_nekumul=$pkg->koop($$vazba{vyporgn},$$vazba{zakn},$vnitr_ceny_nekumul);
   my $posloper;
   foreach my $oper (sort keys %{$vnitr_ceny_nekumul}) {
      foreach my $naklad (@naklady) {
         # zaznam na pocet kusu z kusovniku
         $$vnitr_ceny{$$vazba{vyporgn}}{$$vazba{zakn}}{$oper}{$naklad}+=$$vnitr_ceny{$$vazba{vyporgn}}{$$vazba{zakn}}{$posloper}{$naklad} if(defined($posloper));
         $$vnitr_ceny{$$vazba{vyporgn}}{$$vazba{zakn}}{$oper}{$naklad}+=$$vnitr_ceny_nekumul{$oper}{$naklad};
      }
      $posloper=$oper;
   }
   $vnitr_ceny_posloper{$$vazba{vyporgn}}{$$vazba{zakn}}=$posloper;
   # jeste pricist rezii naradi na zak (vyuziva jen org 6 ostatni to maji v Spolecnost.Rezie.opn2)
   $sth_reziezak->execute($$vazba{zakn},get_env("datum"),get_env("datum"));
   my $ref_reziezak=$sth_reziezak->fetchrow_hashref;
   $sth_reziezak->finish;
   $$vnitr_ceny{$$vazba{vyporgn}}{$$vazba{zakn}}{$posloper}{"opn2"}+=$$ref_reziezak{naradi};
}

#- vypocet vnitr ceny u nakupovanych soucastek
sub vnitr_cena_nakupovana {
   my ($pkg_p, $vazba)=@_;
   # zjisteni cen na jeden kus
   $sth_zakcenik->execute($$vazba{zakn},get_env("datum"),get_env("datum"));
   $pkg->znupl($$vazba{vyporgn},$$vazba{zakn},"1",$sth_zakcenik->rows); # uplnos materialu
   my $ref_zakcenik=$sth_zakcenik->fetchrow_hashref;
   # zaznam na pocet kusu z kusovniku
   $$vnitr_ceny{$$vazba{vyporgn}}{$$vazba{zakn}}{"000"}{mat}=$$ref_zakcenik{cena};
   $sth_zakcenik->finish;
   $vnitr_ceny_posloper{$$vazba{vyporgn}}{$$vazba{zakn}}="000";
}

# Napred vsecky polozky spocitam na urovni jedne operace a pak je nabalim dle kusovniku a operaci
## - tenhle vypocet uskutecnim v docasne tabulce mozna pametove (co bude rychlejsi?)

#- vypocet udaju vykonu
sub vykon {
   my ($pkg_p, $vyporg,$zak,$vnitr_ceny_nekumul)=@_;
   # !!! algoritmus byl prekopirovan take do funkce koop tam pomenen pro ucely koop
   # pripadnou zmenu zde, bude mozna treba udelat i tam !!!
   $sth_vykon->execute($zak,get_env("datum"),get_env("datum"),"1");
   $pkg->znupl($vyporg,$zak,"2",$sth_vykon->rows); # uplnos vykonu
   while(my $ref_vykon=$sth_vykon->fetchrow_hashref) {
      my $takc=Info->tkc($$ref_vykon{tta},$$ref_vykon{tamin});
      my $opnrezie=Vnitr_ceny->opnrezie($takc,$$ref_vykon{str});
      $$vnitr_ceny_nekumul{$$ref_vykon{oper}}{mzda}+=$takc;
      $$vnitr_ceny_nekumul{$$ref_vykon{oper}}{opn1}+=$$opnrezie{opn1};
      $$vnitr_ceny_nekumul{$$ref_vykon{oper}}{opn2}+=$$opnrezie{opn2};
      $$vnitr_ceny_nekumul{$$ref_vykon{oper}}{vyrrez}+=$$opnrezie{vyrrez};
      $$vnitr_ceny_nekumul{$$ref_vykon{oper}}{sprrez}+=$$opnrezie{sprrez};
   }
   $sth_vykon->finish;
   return $vnitr_ceny_nekumul;
}
#- vypocet udaju normativu - ve skutecnosti jen zjistuji existenci normativu nic vic
sub normativ {
   my ($pkg_p, $vyporg,$zak,$vnitr_ceny_nekumul)=@_;
   $sth_normativ->execute($zak,get_env("datum"),get_env("datum"));
   $pkg->znupl($vyporg,$zak,"16",$sth_normativ->rows); # uplnos normativu
   $sth_normativ->finish;
   return $vnitr_ceny_nekumul;
}
#- vypocet udaju materialu
sub mat {
   my ($pkg_p, $vyporg,$zak,$vnitr_ceny_nekumul)=@_;
   $sth_mat_uplnostmatnor->execute($zak,get_env("datum"),get_env("datum"));
   $pkg->znupl($vyporg,$zak,"1",$sth_mat_uplnostmatnor->rows); # uplnost materialu - zde mrkam zda existuje matros na operaci 000 bez ohledu na indikaci a kdi jo tak je to ok (to kaslani na indikaci se mi moc nelibi, ale metodici si to pri urcovani uplnosti materialu prali...)
   $sth_mat_uplnostmatnor->finish;
   $sth_mat->execute($zak,get_env("datum"),get_env("datum"),"1");
   while(my $ref_mat=$sth_mat->fetchrow_hashref) {
      $sth_matcis->execute($$ref_mat{mat},get_env("datum"),get_env("datum"));
      $pkg->znupl($vyporg,$zak,"1",$sth_matcis->rows); # uplnost materialu
      my $ref_matcis=$sth_matcis->fetchrow_hashref;
      $sth_matcis->finish;
      $sth_matcenik->execute($$ref_mat{mat},get_env("datum"),get_env("datum"));
      $pkg->znupl($vyporg,$zak,"1",$sth_matcenik->rows); # uplnost materialu
      my $ref_matcenik=$sth_matcenik->fetchrow_hashref;
      $sth_matcenik->finish;
      my $cena=$$ref_matcenik{cena};
      ## !! V celopodnikovych postupnych souctech nema byt prirazka vubec uplatnena !!
      if(get_env("org") ne "0" and $$ref_matcis{kmorg} ne $vyporg) {
         $cena+=$cena*0.01*$$ref_matcenik{prir};
      }
      # Osetreni pripadu, kdy je v Material_norma mj=11 (g) a v Material mj=12 (kg), ale i mozne osetreni i jinych pripadu (zalezi na funkci Conversion->mj)
      if($$ref_mat{mj} ne $$ref_matcis{mj}) {
         $cena=Conversion->mj($cena,$$ref_mat{mj},$$ref_matcis{mj});
      }
      $$vnitr_ceny_nekumul{$$ref_mat{oper}}{mat}+=$$ref_mat{mnoz}*$cena;
   }
   $sth_mat->finish;
   return $vnitr_ceny_nekumul;
}
#- vypocet udaju kooperace a zruseni vsech ostatnich udaju na kooperacnich operacich
sub koop {
   my ($pkg_p, $vyporg,$zak,$vnitr_ceny_nekumul)=@_;
   $sth_koop->execute(substr($zak,0,13).'%',get_env("datum"),get_env("datum"));
   my @oper;
   # byly nalezeny nejake zaznamy
   if($sth_koop->rows>0) {
      @oper=sort keys(%{$vnitr_ceny_nekumul});
   }
   while(my $ref_koop=$sth_koop->fetchrow_hashref) {
      while(my $oper=shift(@oper)) {
         # likvidace udaju o operacich, ktere jsou v kooperaci
         if($oper ge $$ref_koop{odoper} and $oper le $$ref_koop{dooper}) {
            delete($$vnitr_ceny_nekumul{$oper});
         }
         elsif($oper gt $$ref_koop{dooper}) {
            unshift(@oper,$oper);
            last;
         }
      }
      # v rezimu neceloholdingovem ci holdingovem, ale s tim, ze jde o kooperaci mimo holding - normalka vezmu cenu s ceniku kooperaci
      my $info_kooporg=Info->org(Vyroba_priprava->koop_kooporg($$ref_koop{zak}));
      if(get_env("org") ne "0" or $$info_kooporg{vcorg} ne "1") {
         $$vnitr_ceny_nekumul{$$ref_koop{odoper}}{koop}+=$$ref_koop{cena};
      }
      # pokud jde o interni kooperaci v ramci holdingu tak se mrknu primo do vykonovky te druhe spolecnosti...
      else {
         # !!! algoritmus je puvodne prevzty z funkce vykon a je ji velmi podobny,
         # pripadnou zmenu zde, bude mozna treba udelat i tam !!!
         $sth_vykonkoop->execute($$ref_koop{zak},get_env("datum"),get_env("datum"),"1", $$ref_koop{odoper},$$ref_koop{dooper});
         $pkg->znupl($vyporg,$zak,"2",$sth_vykonkoop->rows); # uplnos vykonu
         while(my $ref_vykonkoop=$sth_vykonkoop->fetchrow_hashref) {
            my $takc=Info->tkc($$ref_vykonkoop{tta},$$ref_vykonkoop{tamin});
            my $opnrezie=Vnitr_ceny->opnrezie($takc,$$ref_vykonkoop{str});
            $$vnitr_ceny_nekumul{$$ref_vykonkoop{oper}}{mzda}+=$takc;
            $$vnitr_ceny_nekumul{$$ref_vykonkoop{oper}}{opn1}+=$$opnrezie{opn1};
            $$vnitr_ceny_nekumul{$$ref_vykonkoop{oper}}{opn2}+=$$opnrezie{opn2};
            $$vnitr_ceny_nekumul{$$ref_vykonkoop{oper}}{vyrrez}+=$$opnrezie{vyrrez};
            $$vnitr_ceny_nekumul{$$ref_vykonkoop{oper}}{sprrez}+=$$opnrezie{sprrez};
         }
         $sth_vykonkoop->finish;
      }
   }
   $sth_koop->finish;
   return $vnitr_ceny_nekumul;
}

#- funkce kontrolujici uplnost - existenci zaznamu
sub znupl {
   my ($pkg_p, $vyporg,$zak,$typ,$rows)=@_;
   if(!($rows>0)) {
      $vnitr_ceny_znupl{$vyporg}{$zak}{$typ}=1;
   }
}

return 1;

