package Vyroba_evidence;

my $pkg="Vyroba_evidence";

use strict;
use My;
use MyXML;
use Kusovnik_norm;
use Info;
use Format;
use Output;

#==== Globalni promena tohohle balicku
my $elementy;
my $dbh=My->dbh;

#- priprava dotazu


#- dotaz zjistujici zda je mozno odvest (uzivam i pri jinezmeny.phtml a take u zmetkovani v ramci odpracvyk.phtml) $mnoz zakazky $zak - prochazi i kusovnikem
# fce vraci undef, kdyz je vse ok nebo hash $zapornystav obsahujici v klici zak, kde by pri odvodu doslo k zapornemu stavu
# !!!! POZOR - vychazim z algoritmu nize, vypozorovanim, kde zapisuji do Vyroba_stav - pokud se zmeni, je treba zmenit i tuto kontrolu !!!!
sub check_zapornystav {
   my ($pkg_p, $zak,$kmint,$str,$strprij,$mnoz)=@_; # !!! pokud je $str=undef, jde o cisty Prijem - ne o odvadeni
   my $zapornystav;
   # dotaz zjistujici stav vyroby
   my $sth_stav=$dbh->prepare(q{
      select
         Vyroba_stav.ksvych+Vyroba_stav.ksprij-Vyroba_stav.kszm-Vyroba_stav.ksodv as stav
      from
         Vyroba_evidence.Vyroba_stav
      where
         Vyroba_stav.org=? and
         Vyroba_stav.zak=? and
         Vyroba_stav.kmint=? and
         Vyroba_stav.str=?
   });
   #- Kontrola Elementu respektive Celku
   # poznamka: Pokud prochazim kusovnikem ma smysl opravdu kontrolovat jen ty posledni elementy a ne celek, jelikoz celek v takovem pripade imaginarne prijmu a vzapeti odvedu,
   #           pokud neprochazim kusovnikem, tak i tak tento algoritmus zafunguje dobre - znamenato, ze odvadim jen celek a tenhle algoritmus mi kontrolu provede (identicky jako u elementu),
   #           jeste je problem pri "zapornem" odvadeni, pak musi vzdy kontrolovat jeste stranu, kde dochazi k automatickemu prijmu (pokud k nemu dochazi)
   # zjisteni souhrneho kusovniku pro elementy
   # pozn: tato cast kontroly ma smysl i kdyz je mnoz zaporne - pokud si pripustim zaporna znamenka v kusovniku, muze se znamenko otocit
   if(defined($str)) { # u cisteho Prijmu neodvadim a tedy tato cast nema smysl
      $elementy=undef;
      if(get_env("vyrtyp") ne "sklhs") { # u sklhs se nedela rozpad (odvadi se jen celek - tuhle nianci zapisu resim primo v prislusne funkci) - kontrolovat budes jen stav celku
         Kusovnik_norm->kusovnik_str(
            Kusovnik->ini({
               zak =>         $zak,
               mnoz =>        $mnoz,
               _funkce =>     "Kusovnik_norm->kusovnik_str",
               _funkce_str => "Vyroba_evidence->check_zapornystav_elementy",
               _str =>        $str,
               _odkmint =>    $kmint,
               _indmax =>     1
            })
         );
      }
      else { # pro ucely sklhs - kontrolovat budu jen celek
         # radky nize musi byt v souladu s fci Vyroba_evidence->check_zapornystav_elementy
         $$elementy{$zak}{$kmint}{mnoz}=$mnoz;
         $$elementy{$zak}{$kmint}{kmorg}=get_env("org"); # no uplne koser tohle asi neni
      }
      foreach my $zakn (keys %{$elementy}) {
         foreach my $kmintn (keys %{$$elementy{$zakn}}) {
            $sth_stav->execute(get_env("org"),$zakn,$kmintn,$str);
            my $ref_stav=$sth_stav->fetchrow_hashref;
            $sth_stav->finish;
            if($$ref_stav{stav}-$$elementy{$zakn}{$kmintn}{mnoz}<0) {
               $$zapornystav{$zakn}{$kmintn}{mnoz}=$$elementy{$zakn}{$kmintn}{mnoz};
               $$zapornystav{$zakn}{$kmintn}{stav}=$$ref_stav{stav};
               $$zapornystav{$zakn}{$kmintn}{str}=$str;
            }
         }
      }
   }
   # tato cast kontroly ma smysl jen pokud je $mnoz zaporne (kvuli prevenci a moznosti jiz zapornych stavu, ji delam vzdy) a dochazi k automatickemu zapisu celku do prijmu
   if(defined($strprij) and $pkg->maybe_autoprijem($strprij)) {
      my $kmintv;
      if(defined($str)) { # jde o odvadeni - prijma se na nasledujici kmint za $kmint
         $kmintv=$pkg->kmintv($zak,$kmint); # zjisteni nasledujiciho kmint
      }
      else { # jde o cisty prijem - prijma se na $kmint
         $kmintv=$kmint;
      }
      $sth_stav->execute(get_env("org"),$zak,$kmintv,$strprij);
      my $ref_stav=$sth_stav->fetchrow_hashref;
      $sth_stav->finish;
      if($$ref_stav{stav}+$mnoz<0) {
         $$zapornystav{$zak}{$kmintv}{mnoz}=-1*$mnoz;
         $$zapornystav{$zak}{$kmintv}{stav}=$$ref_stav{stav};
         $$zapornystav{$zak}{$kmintv}{str}=$strprij;
      }
   }
   return $zapornystav;
}

# kontrola na zaporny stav pri odvadeni sklrv - je tam tolik nianci, ze ho resim spec funkci
sub check_zapornystav_rv {
   my ($pkg_p, $zak,$kmint,$str,$strprij,$mnoz)=@_;
   my $zapornystav;
   # dotaz zjistujici stav vyroby
   my $sth_stav=$dbh->prepare(q{
      select
         Vyroba_stav.ksvych+Vyroba_stav.ksprij-Vyroba_stav.kszm-Vyroba_stav.ksodv as stav
      from
         Vyroba_evidence.Vyroba_stav
      where
         Vyroba_stav.org=? and
         Vyroba_stav.zak=? and
         Vyroba_stav.kmint=? and
         Vyroba_stav.str=?
   });
   #- Kontrola Elementu respektive Celku
   # poznamka: Pokud prochazim kusovnikem ma smysl opravdu kontrolovat jen ty posledni elementy - jelikoz u odvadeni sklrv se zapisuji na obou stranach jen elementy
   #           pokud neprochazim kusovnikem, tak i tak tento algoritmus zafunguje dobre - znamenato, ze odvadim jen celek a tenhle algoritmus mi kontrolu provede (identicky jako u elementu),
   # zjisteni souhrneho kusovniku pro elementy
   $elementy=undef;
   Kusovnik_norm->kusovnik_str(
      Kusovnik->ini({
         zak =>         $zak,
         mnoz =>        $mnoz,
         _funkce =>     "Kusovnik_norm->kusovnik_str",
         _funkce_str => "Vyroba_evidence->check_zapornystav_elementy",
         _str =>        $strprij, # rozpadam dle $strprij (to je ok - strprij je vys nez str odvadci)
         _odkmint =>    $kmint,
         _indmax =>     1
      })
   );
   foreach my $zakn (keys %{$elementy}) {
      foreach my $kmint (keys %{$$elementy{$zakn}}) {
         if($$elementy{$zakn}{$kmint}{kmorg} ne "0") { # zakazky z kmorg 0 me nezajimaji ty nezapisuji
            # kontrola u strodv - tato cast ma smysl jen pokud je $$elementy{$zakn}{$kmint}{mnoz} kladne (schvalne se neptam na $mnoz - pokud si pripustim zapory v kusovniku, mohlo se znamenko otocit) - ja ji ovsem delam vzdy jako prevenci, kdyby uz byl stav zaporny...
            $sth_stav->execute(get_env("org"),$zakn,$kmint,$str);
            my $ref_stav=$sth_stav->fetchrow_hashref;
            $sth_stav->finish;
            if($$ref_stav{stav}-$$elementy{$zakn}{$kmint}{mnoz}<0) {
               $$zapornystav{$zakn}{$kmint}{mnoz}=$$elementy{$zakn}{$kmint}{mnoz};
               $$zapornystav{$zakn}{$kmint}{stav}=$$ref_stav{stav};
               $$zapornystav{$zakn}{$kmint}{str}=$str;
            }
            # kontrola u strprij -  tato cast ma smysl jen pokud je $mnoz zaporne a jde o pripad automatickeho prijmu - kvuli prevenci jiz zapornych stavu, ji delam vzdy
            if($pkg->maybe_autoprijem($strprij)) {
               $sth_stav->execute(get_env("org"),$zakn,$kmint,$strprij);
               my $ref_stav=$sth_stav->fetchrow_hashref;
               $sth_stav->finish;
               if($$ref_stav{stav}+$$elementy{$zakn}{$kmint}{mnoz}<0) {
                  $$zapornystav{$zakn}{$kmint}{mnoz}=-1*$$elementy{$zakn}{$kmint}{mnoz};
                  $$zapornystav{$zakn}{$kmint}{stav}=$$ref_stav{stav};
                  $$zapornystav{$zakn}{$kmint}{str}=$strprij;
               }
            }
         }
      }
   }
   return $zapornystav;
}

#- pomocny dotaz pro check_zapornystav
sub check_zapornystav_elementy {
   my ($pkg_p, $vazba)=@_;
   # pripadna uprava teto fce musi asi vyvolat upravu fce Vyroba_evidence->check_zapornystav v sekcich, kde se resi niance nerozpadani u skladu sklhs
   $$elementy{$$vazba{zakn}}{$$vazba{kmint}}{mnoz}+=$$vazba{mnozc};
   $$elementy{$$vazba{zakn}}{$$vazba{kmint}}{kmorg}=$$vazba{kmorg};
}

#- fce tiskne seznam zakazek, kde by odvedenim ci v jinezmeny ci u zmetkovani v odpracvyk vznikl zaporny stav
sub print_zapornystav {
   my ($pkg_p, $tO,$outputdev,$zapornystav)=@_;
   $tO->aT("h2", {}, "Seznam zakzek, kde by vznikl zporn stav");
   #= Tabulka
   # vytvoreni xml dokumentu i s korenem table
   my ($docI,$table,$cols,$rows)=MyXML->creatable;
   # popis sloupcu
   foreach my $colname ("Zak","Kmint","St") {
      $cols->aT("col",{},$colname);
   }
   foreach my $colname ("Stav","Poadavek","Rozdl") {
      $cols->aT("col",{ type=>"number", format=>"#,##0" },$colname);
   }
   foreach my $zakn (sort keys %{$zapornystav}) {
      my $row=$rows->aT("row",{chosen=>"0"});
      my $info_zak=Info->zak($zakn);
      foreach my $kmint (sort keys %{$$zapornystav{$zakn}}) {
         my $colO=$row->aT("col");
         my $xhtmlO=$colO->aT("xhtml");
         Output->outputzak($xhtmlO,$info_zak);
         $row->aT("col", {}, $kmint);
         $row->aT("col", {}, $$zapornystav{$zakn}{$kmint}{str});
         $row->aT("col", {}, $$zapornystav{$zakn}{$kmint}{stav});
         $row->aT("col", {}, $$zapornystav{$zakn}{$kmint}{mnoz});
         $row->aT("col", {}, $$zapornystav{$zakn}{$kmint}{stav}-$$zapornystav{$zakn}{$kmint}{mnoz});
      }
   }
   my $preO=Output->pre($tO,$outputdev);
   Output->output($preO,$table,$outputdev);
}

#- funkce volana z kusovnik_str pri "hromadne" odvadeni odpracovaneho vykonu vetsinou nejake sestavy, kterou dela kolektiv
# tahle funkce je uzita i pro zapis na uplne prvnim kmint (i pro "celek") - to obdobna fce write_odvadeni_pruchod, ktera je nize ma schvalne podminu, aby tento pripad vynechavala a ten je pak resen samostatne
sub write_odprvykkol_pruchod {
   my ($pkg_p, $vazba)=@_;
   # pokud jde o uplne prvni volani (pro celek) z prvniho sledu a pro prvni kmint, tak jeste nevim udaje odoper a dooper a tak je zde urcim
   if(!($$vazba{sled}>0 or ($$vazba{sled}==0 and $$vazba{_odkmint} ne $$vazba{kmint}))) {
      my $info_norm=Info->normativy($$vazba{zak},$$vazba{kmint});
      $$info_norm{kmint}=$$vazba{kmint};
      $info_norm=Kusovnik_norm->PokudNeni_odoper_dooper_UrciJe($info_norm); # pokud jsem normativy nenalezl, je treba si nektere udaje "vymyslet" - melo by to nastavat jen u pripadu odvadeni ze skladu sklhs, kdy kmint je 999
      $$vazba{odoper}=$$info_norm{odoper};
      $$vazba{dooper}=$$info_norm{dooper};
   }
   $pkg->write_odpracvyk(
      {
         zakn => $$vazba{zakn},
         strodv => $$vazba{_str},
         mnozc => $$vazba{mnozc},
         odoper => $$vazba{odoper},
         dooper => $$vazba{dooper},
         kmint => $$vazba{kmint},
         prik => "", # muze jich byt i vice proto ""
         pozn => $$vazba{pozn}
      }
   );
}

#- funkce volana z kusovnik_str pri Odvadeni (!! ale i u jinezmeny ci u zmetkovani v odpracvyk !!), zapisuje na urovni kazdeho kmint nizsiho nez ten uvodni
sub write_odvadeni_pruchod {
   my ($pkg_p, $vazba)=@_;
   if($$vazba{sled}>0 or ($$vazba{sled}==0 and $$vazba{_odkmint} ne $$vazba{kmint})) {
      $pkg->write_vyrprikazy_ksvyk(
         $$vazba{zakn},
         $$vazba{kmint},
         $$vazba{_str},
         $$vazba{mnozc}
      );
      ## ZMENA 2002-12-07 - zapis odpracvyk byl drive az ve fci write_odvadeni_elementy, coz bylo spatne
      # Odpracvyk pokud znr=2
      if($$vazba{znr} eq "2") { ## ZMENA 2002-12-02 - jeste tu bylo omezeni jen na dilny dilopt a dilpu - tohle omezeni jsem zrusil
         $pkg->write_odpracvyk(
            {
               zakn => $$vazba{zakn},
               strodv => $$vazba{_str},
               mnozc => $$vazba{mnozc},
               odoper => $$vazba{odoper},
               dooper => $$vazba{dooper},
               kmint => $$vazba{kmint},
               prik => "", # muze jich byt i vice proto ""
               pozn => $$vazba{pozn}
            }
         );
      }
   }
}

#- funkce volana z kusovnik_str pri Odvadeni, zapisuje elementy do odvadeni (zadarmo) a ponizuje stav - (teoreticky "elementy" nemusi byt jen soucastky, muze jit i primo o hlavni zakazku, ale na nizsim kmint)
# !!! Poznamka (2002-11-12): Tyhle zapsane vety zadarmo poznam z podminky strodv=strprij (informoval jsem takto i Geryka)
sub write_odvadeni_elementy {
   my ($pkg_p, $vazba)=@_;
   if($$vazba{sled}>0 or ($$vazba{sled}==0 and $$vazba{_odkmint} ne $$vazba{kmint})) {
      set_env("odvadeni_elementy",1); # zaznam do pomocne globalni promene prostredi, ze byly odvadeny elementy
      #- ZAPISY pro strodv
      # Odvadeni
      Write->insert({
         _table => "Vyroba_evidence.Odvadeni",
         org => get_env("org"),
         ucetobd => substr(get_env("datum"),0,7),
         strodv => $$vazba{_str},
         zak => $$vazba{zakn},
         oper => $$vazba{dooper},
         zakaznikico => $$vazba{zakaznikico},
         strprij => $$vazba{_str},
         termin => $$vazba{termin},
         cisobj => $$vazba{cisobj},
         skup => $$vazba{skup},
         kmint => $$vazba{kmint},
         prik => "", # muze jich byt i vice proto ""
         ksodv => $$vazba{mnozc},
         matc =>  "0",
         koopc => "0",
         mzdac => "0",
         opn1c => "0",
         opn2c => "0",
         vyrrezc => "0",
         sprrezc => "0",
         cenac => $$vazba{cenac},
         znr => $$vazba{znr},
         ucet => $$vazba{ucet},
         zakcelek => $$vazba{zak},
         pozn => $$vazba{pozn}
      });
      # Vyroba_stav
      Write->replace({
         _table => "Vyroba_evidence.Vyroba_stav",
         _key_org => get_env("org"),
         _key_zak => $$vazba{zakn},
         _key_kmint => $$vazba{kmint},
         _key_str => $$vazba{_str},
         _add_ksodv => $$vazba{mnozc},
         datodv => My->date_now,
         datzapis => My->datetime_now,
         uzivzapis => My->remote_user
      });
   }
}

#- funkce volana z kusovnik_str pri jinezmeny ci u zmetkovani v odpracvyk, ponizuje stav - (teoreticky "elementy" nemusi byt jen soucastky, muze jit i primo o hlavni zakazku, ale na nizsim kmint)
# Poznamka: pokud jde progtyp "zmetkyodprvyk" tak by to sem nemelo nikdy jit, v techto pripadech nerozpadam a vse jsem jiz rozpadl a zapsal pri odvadeni odpracovaneho vykonu
sub write_jinezmeny_elementy {
   my ($pkg_p, $vazba)=@_;
   if($$vazba{sled}>0 or ($$vazba{sled}==0 and $$vazba{_odkmint} ne $$vazba{kmint})) {
      set_env("odvadeni_elementy",1); # zaznam do pomocne globalni promene prostredi, ze byly odvadeny elementy
      #- ZAPISY
      # JineZmeny - nove od 2002-11-21 - rozhodl jses zadarmo zapisovat do souboru JineZmeny i "zmetkovani" jednotlivych elementu
      Write->insert({
         _table => "Vyroba_evidence.JineZmeny",
         org => get_env("org"),
         ucetobd => substr(get_env("datum"),0,7), # poznamka: pokud jde o zapis v ramci odvadeni odpracovaneho vykonu, tak i zde zapisi aktualni ucetni obdobi, jelikoz elementy "zadarmo" nebudou pozdeji likvidovany - likvidace se ucastni jen pripadna sestava (myslim, ze nevadi pokud k tomu dojde v jinem ucetnim obdobi, i kdyz to bude jisty nesoulad)
         kmstrvys => $$vazba{_str},
         zak => $$vazba{zakn},
         oper => $$vazba{dooper},
         hlaseni => $$vazba{hlaseni},
         kmint => $$vazba{kmint},
         prik => "", # muze jich byt i vice proto ""
         kszm => $$vazba{mnozc},
         znzm => $$vazba{znzm},
         priczm => $$vazba{priczm},
         strvys => $$vazba{strvys},
         strvin => $$vazba{strvin},
         oc => $$vazba{oc},
         uhrada => $$vazba{uhrada},
         matc =>  "0",
         koopc => "0",
         mzdac => "0",
         opn1c => "0",
         opn2c => "0",
         vyrrezc => "0",
         sprrezc => "0",
         datvys => $$vazba{datvys},
         zakcelek => $$vazba{zak},
         pozn => $$vazba{pozn}
      });
      # Vyroba_stav
      Write->replace({
         _table => "Vyroba_evidence.Vyroba_stav",
         _key_org => get_env("org"),
         _key_zak => $$vazba{zakn},
         _key_kmint => $$vazba{kmint},
         _key_str => $$vazba{_str},
         _add_kszm => $$vazba{mnozc},
         datzm => My->date_now,
         datzapis => My->datetime_now,
         uzivzapis => My->remote_user
      });
   }
}

#- funkce je volana primo ze zapisovaciho programu pri Odvadeni - zpusob a co se zapisuje se lisi dle toho zda jiz predchazel zapis do elementu
sub write_odvadeni_celek {
   my ($pkg_p, $vazba)=@_;
   # pohled do normativu
   ## ZMENA 2003-01-13
   #my $info_norm=Info->normativy($$vazba{zak},$$vazba{kmint});
   my $info_norm=Vyroba->normativypoc(Info->zak($$vazba{zak}),$$vazba{kmint},$$vazba{strodv});
   $$info_norm{kmint}=$$vazba{kmint};
   $info_norm=Kusovnik_norm->PokudNeni_odoper_dooper_UrciJe($info_norm); # pokud jsem normativy nenalezl, je treba si nektere udaje "vymyslet" - melo by to nastavat jen u pripadu odvadeni ze skladu sklhs, kdy kmint je 999
   ## ZMENA 2003-02-25
   # pokud je operace jiz presne urcena - pripad odvadeni z rozpracovane vyroby ven z konkretni operace - tak ji budu respektovat
   if(length($$vazba{oper})) {
      $$info_norm{dooper}=$$vazba{oper};
   }
   # zjisteni udaju o zaceneni
   my $info_vnitr_ceny=Info->vnitr_ceny($$vazba{zak},$$info_norm{dooper});
   #- ZAPISY pro strodv
   # Odvadeni
   Write->insert({
      _table => "Vyroba_evidence.Odvadeni",
      org => get_env("org"),
      ucetobd => substr(get_env("datum"),0,7),
      strodv => $$vazba{strodv},
      zak => $$vazba{zak},
      oper => $$info_norm{dooper},
      zakaznikico => $$vazba{zakaznikico},
      strprij => $$vazba{strprij},
      termin => $$vazba{termin},
      cisobj => $$vazba{cisobj},
      skup => $$vazba{skup},
      kmint => $$vazba{kmint},
      prik => $$vazba{prik},
      ksodv => $$vazba{ksodv},
      matc =>  $$vazba{ksodv}*$$info_vnitr_ceny{mat},
      koopc => $$vazba{ksodv}*$$info_vnitr_ceny{koop},
      mzdac => $$vazba{ksodv}*$$info_vnitr_ceny{mzda},
      opn1c => $$vazba{ksodv}*$$info_vnitr_ceny{opn1},
      opn2c => $$vazba{ksodv}*$$info_vnitr_ceny{opn2},
      vyrrezc => $$vazba{ksodv}*$$info_vnitr_ceny{vyrrez},
      sprrezc => $$vazba{ksodv}*$$info_vnitr_ceny{sprrez},
      cenac => $$vazba{cenac},
      znr => $$vazba{znr},
      ucet => $$vazba{ucet},
      zakcelek => "",
      pozn => $$vazba{pozn}
   });
   # pokud jsem prochazel kusovnikem tak na celku se nevede stav, ja protoze ovsem menim kolonku odvadeni musim tak imaginarnim prijmem vynulovat stav
   if($$vazba{_odvadeni_elementy}) {
      # Prijem (imaginarni prijem)
      Write->insert({
         _table => "Vyroba_evidence.Prijem",
         org => get_env("org"),
         ucetobd => substr(get_env("datum"),0,7),
         strprij => $$vazba{strodv},
         zak => $$vazba{zak},
         oper => $$info_norm{odoper},
         strodv => $$vazba{strodv},
         cisvyd => "",
         kmint => $$vazba{kmint},
         prik => $$vazba{prik},
         ksprij => $$vazba{ksodv},
         matc =>  "0",
         koopc => "0",
         mzdac => "0",
         opn1c => "0",
         opn2c => "0",
         vyrrezc => "0",
         sprrezc => "0",
         znr => $$vazba{znr},
         ucet => $$vazba{ucet},
         zakcelek => "",
         pozn => $$vazba{pozn}
      });
      # Vyroba_stav (imaginarni prijem)
      Write->replace({
         _table => "Vyroba_evidence.Vyroba_stav",
         _key_org => get_env("org"),
         _key_zak => $$vazba{zak},
         _key_kmint => $$vazba{kmint},
         _key_str => $$vazba{strodv},
         _add_ksprij => $$vazba{ksodv},
         datprij => My->date_now,
         datzapis => My->datetime_now,
         uzivzapis => My->remote_user
      });
   }
   # Vyroba_stav
   Write->replace({
      _table => "Vyroba_evidence.Vyroba_stav",
      _key_org => get_env("org"),
      _key_zak => $$vazba{zak},
      _key_kmint => $$vazba{kmint},
      _key_str => $$vazba{strodv},
      _add_ksodv => $$vazba{ksodv},
      datodv => My->date_now,
      datzapis => My->datetime_now,
      uzivzapis => My->remote_user
   });
   if($$vazba{_vyrtyp} eq "dilmech") { # pozn u dilopt (a tedy i u dilpu) to resim zvlast ve fci protoze neni jasne urcen prikaz - nyni (od 2002-06-21) to stejne jako u dilopt delas i u dilmon a sklhs
      # Vyrprikazy
      Write->replace({
         _table => "Vyroba_planovani.Vyrprikazy",
         _key_org => get_env("org"),
         _key_zak => $$vazba{zak},
         _key_kmint => $$vazba{kmint},
         _key_prik => $$vazba{prik},
         _add_ksvyk => $$vazba{ksodv},
         datvyk => My->date_now,
         datzapis => My->datetime_now,
         uzivzapis => My->remote_user
      });
   }
   elsif($$vazba{_vyrtyp} eq "dilmon" or $$vazba{_vyrtyp} eq "sklhs") {
      # Objednavky
      Write->replace({
         _table => "Vyroba_planovani.Objednavky",
         _key_org => get_env("org"),
         _key_zak => $$vazba{zak},
         _key_zakaznikico => $$vazba{zakaznikico},
         _key_zakaznikstr => $$vazba{strprij},
         _key_termin => $$vazba{termin},
         _key_cisobj => $$vazba{cisobj},
         _key_skup => $$vazba{skup},
         _add_ksvyk => $$vazba{ksodv},
         datvyk => My->date_now,
         _bezdatzapis => 1
      });
   }
   # Odpracvyk pokud znr=2
   if($$vazba{znr} eq "2") { ## ZMENA 2002-12-02 - jeste tu bylo omezeni jen na dilny dilopt a dilpu - tohle omezeni jsem zrusil
      $pkg->write_odpracvyk(
         {
            zakn => $$vazba{zak},
            strodv => $$vazba{strodv},
            mnozc => $$vazba{ksodv},
            odoper => $$info_norm{odoper},
            dooper => $$info_norm{dooper},
            kmint => $$vazba{kmint},
            prik => $$vazba{prik},
            pozn => $$vazba{pozn}
         }
      );
   }
   #- ZAPISY pro strprij
   if($pkg->maybe_autoprijem($$vazba{strprij})) { # zapisuji jen pokud strprij je stredisko, kde se sleduje evidence vyroby
      my $kmintv=$pkg->kmintv($$vazba{zak},$$vazba{kmint}); # zjisteni nasledujiciho kmint
      # Prijem
      Write->insert({
         _table => "Vyroba_evidence.Prijem",
         org => get_env("org"),
         ucetobd => substr(get_env("datum"),0,7),
         strprij => $$vazba{strprij},
         zak => $$vazba{zak},
         oper => $$info_norm{dooper},
         strodv => $$vazba{strodv},
         cisvyd => "",
         kmint => $kmintv,
         prik => $$vazba{prik},
         ksprij => $$vazba{ksodv},
         matc =>  $$vazba{ksodv}*$$info_vnitr_ceny{mat},
         koopc => $$vazba{ksodv}*$$info_vnitr_ceny{koop},
         mzdac => $$vazba{ksodv}*$$info_vnitr_ceny{mzda},
         opn1c => $$vazba{ksodv}*$$info_vnitr_ceny{opn1},
         opn2c => $$vazba{ksodv}*$$info_vnitr_ceny{opn2},
         vyrrezc => $$vazba{ksodv}*$$info_vnitr_ceny{vyrrez},
         sprrezc => $$vazba{ksodv}*$$info_vnitr_ceny{sprrez},
         znr => $$vazba{znr},
         ucet => $$vazba{ucet},
         zakcelek => "",
         pozn => $$vazba{pozn}
      });
      # Vyroba_stav
      Write->replace({
         _table => "Vyroba_evidence.Vyroba_stav",
         _key_org => get_env("org"),
         _key_zak => $$vazba{zak},
         _key_kmint => $kmintv,
         _key_str => $$vazba{strprij},
         _add_ksprij => $$vazba{ksodv},
         datprij => My->date_now,
         datzapis => My->datetime_now,
         uzivzapis => My->remote_user
      });
   }
   elsif($pkg->maybe_autoprijem_sklhv($$vazba{strprij})) { ## 2003-04-01 - sklhv org 6 prechazi pod spravu org 3 a automatika se rusi - fce maybe_autoprijem_sklhv vzdy vraci hodnotu 0
      # Zjisteni cisla varianty - pokud je jina cena => dalsi varianta
      my $cenaks=$$info_vnitr_ceny{uvn}-$$info_vnitr_ceny{sprrez};
      my $var;
      my $sth_sklhv=$dbh->prepare(q{
         select
            StavHV.var
         from
            Vyroba_evidence.StavHV
         where
            StavHV.org=? and
            StavHV.zak=? and
            StavHV.str=? and
            StavHV.ucet=? and
            StavHV.cenaks=?
      });
      $sth_sklhv->execute(get_env("org"),$$vazba{zak},$$vazba{strprij},$$vazba{ucet},$cenaks);
      my $ref_sklhv=$sth_sklhv->fetchrow_hashref;
      $sth_sklhv->finish;
      if(length($$ref_sklhv{var})) {
         $var=$$ref_sklhv{var};
      }
      else {
         my $sth_sklhv=$dbh->prepare(q{
            select
               StavHV.var
            from
               Vyroba_evidence.StavHV
            where
               StavHV.org=? and
               StavHV.zak=? and
               StavHV.str=?
            order by
               StavHV.var desc
            limit
               1
         });
         $sth_sklhv->execute(get_env("org"),$$vazba{zak},$$vazba{strprij});
         my $ref_sklhv=$sth_sklhv->fetchrow_hashref;
         $sth_sklhv->finish;
         $var=sprintf("%2.2d",1*$$ref_sklhv{var}+1);
      }
      # PrijemHV
      Write->insert({
         _table => "Vyroba_evidence.PrijemHV",
         org => get_env("org"),
         zak => $$vazba{zak},
         var => $var,
         strprij => $$vazba{strprij},
         ucetobd => substr(get_env("datum"),0,7), ## ZMENA 2003-01-27 ucetni obdobi zde ma byt - na pristrojich nedochazi k parovani s fakturama!!! tedy drivejsi poznamka nebyla ok: # zatim nic - pokd se nepletu to se tam zapise az po vyfakturovani
         strodv => $$vazba{strodv},
         ksprij => $$vazba{ksodv},
         pozn => $$vazba{pozn}
      });
      # StavHV
      Write->replace({
         _table => "Vyroba_evidence.StavHV",
         _key_org => get_env("org"),
         _key_zak => $$vazba{zak},
         _key_var => $var,
         _key_str => $$vazba{strprij},
         _add_ks => $$vazba{ksodv},
         ucet => $$vazba{ucet},
         cenaks => $cenaks,
         datprij => My->date_now,
         datzapis => My->datetime_now,
         uzivzapis => My->remote_user
      });
   }
}

#- funkce volana z kusovnik_str pri Odvadeni RV
sub write_odvadeni_rv {
   my ($pkg_p, $vazba)=@_;
   if($$vazba{kmorg} ne "0") {
      # zjisteni udaju o zaceneni
      ## ZMENA 2003-01-14  - jelikoz rozpadam od strprij tak se na nem zastavim a vlastne nedosjdu az k sklrv - to az nasleduje a proto tyhle silenosti
      #my $info_vnitr_ceny=Info->vnitr_ceny($$vazba{zakn},$$vazba{dooper});
      my $info_normativy=Vyroba->normativypoc(Info->zak($$vazba{zakn}),$$vazba{kmint},$$vazba{strodv});
      $info_normativy=Kusovnik_norm->PokudNeni_odoper_dooper_UrciJe($info_normativy); # pokud jsem normativy nenalezl, je treba si nektere udaje "vymyslet" - k tomu by, ale zde dojit nemelo
      $$vazba{dooper}=$$info_normativy{dooper}; # prevalcovani dooper z rozpadu
      my $info_vnitr_ceny=Info->vnitr_ceny($$vazba{zakn},$$vazba{dooper});
      # zakcelek
      my $zakcelek;
      if($$vazba{zakn} ne $$vazba{zak}) {
         $zakcelek=$$vazba{zak};
      }
      else {
         $zakcelek="";
      }
      #- ZAPISY pro strodv
      # Odvadeni
      Write->insert({
         _table => "Vyroba_evidence.Odvadeni",
         org => get_env("org"),
         ucetobd => substr(get_env("datum"),0,7),
         strodv => $$vazba{strodv},
         zak => $$vazba{zakn},
         oper => $$vazba{dooper},
         zakaznikico => "",
         strprij => $$vazba{_str},
         termin => "",
         cisobj => "",
         skup => "",
         kmint => $$vazba{kmint},
         prik => $$vazba{prik}, ## ZMENA 2002-11-18 - drive jen ""
         ksodv => $$vazba{mnozc},
         matc =>  $$vazba{mnozc}*$$info_vnitr_ceny{mat},
         koopc => $$vazba{mnozc}*$$info_vnitr_ceny{koop},
         mzdac => $$vazba{mnozc}*$$info_vnitr_ceny{mzda},
         opn1c => $$vazba{mnozc}*$$info_vnitr_ceny{opn1},
         opn2c => $$vazba{mnozc}*$$info_vnitr_ceny{opn2},
         vyrrezc => $$vazba{mnozc}*$$info_vnitr_ceny{vyrrez},
         sprrezc => $$vazba{mnozc}*$$info_vnitr_ceny{sprrez},
         cenac => $$vazba{cenac},
         znr => $$vazba{znr},
         ucet => $$vazba{ucet},
         zakcelek => $zakcelek,
         pozn => $$vazba{pozn}
      });
      # Vyroba_stav
      Write->replace({
         _table => "Vyroba_evidence.Vyroba_stav",
         _key_org => get_env("org"),
         _key_zak => $$vazba{zakn},
         _key_kmint => $$vazba{kmint},
         _key_str => $$vazba{strodv},
         _add_ksodv => $$vazba{mnozc},
         datodv => My->date_now,
         datzapis => My->datetime_now,
         uzivzapis => My->remote_user
      });
      #- ZAPISY pro strprij
      if($pkg->maybe_autoprijem($$vazba{_str})) { # zapisuji jen pokud strprij je stredisko, kde se sleduje evidence vyroby
         # Prijem
         Write->insert({
            _table => "Vyroba_evidence.Prijem",
            org => get_env("org"),
            ucetobd => substr(get_env("datum"),0,7),
            strprij => $$vazba{_str},
            zak => $$vazba{zakn},
            oper => $$vazba{dooper},
            strodv => $$vazba{strodv},
            cisvyd => "",
            kmint => $$vazba{kmint},
            prik => $$vazba{prik}, ## ZMENA 2002-11-18 - drive jen ""
            ksprij => $$vazba{mnozc},
            matc =>  $$vazba{mnozc}*$$info_vnitr_ceny{mat},
            koopc => $$vazba{mnozc}*$$info_vnitr_ceny{koop},
            mzdac => $$vazba{mnozc}*$$info_vnitr_ceny{mzda},
            opn1c => $$vazba{mnozc}*$$info_vnitr_ceny{opn1},
            opn2c => $$vazba{mnozc}*$$info_vnitr_ceny{opn2},
            vyrrezc => $$vazba{mnozc}*$$info_vnitr_ceny{vyrrez},
            sprrezc => $$vazba{mnozc}*$$info_vnitr_ceny{sprrez},
            znr => $$vazba{znr},
            ucet => $$vazba{ucet},
            zakcelek => $zakcelek,
            pozn => $$vazba{pozn}
         });
         # Vyroba_stav
         Write->replace({
            _table => "Vyroba_evidence.Vyroba_stav",
            _key_org => get_env("org"),
            _key_zak => $$vazba{zakn},
            _key_kmint => $$vazba{kmint},
            _key_str => $$vazba{_str},
            _add_ksprij => $$vazba{mnozc},
            datprij => My->date_now,
            datzapis => My->datetime_now,
            uzivzapis => My->remote_user
         });
      }
   }
}

#- funkce je volana primo ze zapisovaciho programu pri zapisu zmetu, mank, ...
sub write_jinezmeny_celek {
   my ($pkg_p, $vazba)=@_;
   # zjisteni udaju o zaceneni - pokud je zmetek neplaceny (znzm=0), zaceneni bude bez operace, kde ke zmetku doslo
   my $info_vnitr_ceny=$pkg->vnitr_ceny_jinezmeny($$vazba{zak},$$vazba{oper},$$vazba{znzm});
   # urceni ucetniho obdobi - v pripade zapisu z odpracvyk.phtml das "0000-00" coz znaci jeste nezlikvidovane zmetky, ktere je treba pozdeji zlikvidovat v ramci jinezmeny.phtml (vazane na odpr.vykon)
   my $ucetobd;
   if(get_env("progtyp") ne "odprvykvyrprikazy" and get_env("progtyp") ne "odprvyk") {
      $ucetobd=substr(get_env("datum"),0,7);
   }
   else {
      $ucetobd="0000-00";
   }
   #- ZAPISY
   # JineZmeny
   Write->insert({
      _table => "Vyroba_evidence.JineZmeny",
      org => get_env("org"),
      ucetobd => $ucetobd,
      kmstrvys => $$vazba{kmstrvys},
      zak => $$vazba{zak},
      oper => $$vazba{oper},
      hlaseni => $$vazba{hlaseni},
      kmint => $$vazba{kmint},
      prik => $$vazba{prik},
      kszm => $$vazba{kszm},
      znzm => $$vazba{znzm},
      priczm => $$vazba{priczm},
      strvys => $$vazba{strvys},
      strvin => $$vazba{strvin},
      oc => $$vazba{oc},
      uhrada => $$vazba{uhrada},
      matc =>  $$vazba{kszm}*$$info_vnitr_ceny{mat},
      koopc => $$vazba{kszm}*$$info_vnitr_ceny{koop},
      mzdac => $$vazba{kszm}*$$info_vnitr_ceny{mzda},
      opn1c => $$vazba{kszm}*$$info_vnitr_ceny{opn1},
      opn2c => $$vazba{kszm}*$$info_vnitr_ceny{opn2},
      vyrrezc => $$vazba{kszm}*$$info_vnitr_ceny{vyrrez},
      sprrezc => $$vazba{kszm}*$$info_vnitr_ceny{sprrez},
      datvys => $$vazba{datvys},
      zakcelek => "",
      pozn => $$vazba{pozn}
   });
   # pokud jde o "zmetkyodprvyk", stav a vyrobni prik. byl jiz zmenet pri odvadeni Odpracovaneho vykonu
   if(get_env("progtyp") ne "zmetkyodprvyk") {
      # pokud jsem prochazel kusovnikem tak na celku se nevede stav, ja protoze ovsem menim kolonku jine zmeny musim tak imaginarnim prijmem vynulovat stav
      if($$vazba{_odvadeni_elementy}) {
         # Prijem (imaginarni prijem)
         Write->insert({
            _table => "Vyroba_evidence.Prijem",
            org => get_env("org"),
            ucetobd => substr(get_env("datum"),0,7), # imaginarni prijem vzdy budu psat do akt obdobi - pozdeji ho "nelikviduji"
            strprij => $$vazba{kmstrvys},
            zak => $$vazba{zak},
            oper => $$vazba{oper},
            strodv => $$vazba{kmstrvys}, # nemam v prijmu udaj kmstrvys (repektive strzm) a tak to mastim sem
            cisvyd => "",
            kmint => $$vazba{kmint},
            prik => $$vazba{prik},
            ksprij => $$vazba{kszm},
            matc =>  "0",
            koopc => "0",
            mzdac => "0",
            opn1c => "0",
            opn2c => "0",
            vyrrezc => "0",
            sprrezc => "0",
            znr => "9", # specialne znR urceny pro zmetkovani
            ucet => "",
            zakcelek => "",
            pozn => $$vazba{pozn}
         });
         # Vyroba_stav (imaginarni prijem)
         Write->replace({
            _table => "Vyroba_evidence.Vyroba_stav",
            _key_org => get_env("org"),
            _key_zak => $$vazba{zak},
            _key_kmint => $$vazba{kmint},
            _key_str => $$vazba{kmstrvys},
            _add_ksprij => $$vazba{kszm},
            datprij => My->date_now,
            datzapis => My->datetime_now,
            uzivzapis => My->remote_user
         });
      }
      # Vyroba_stav
      Write->replace({
         _table => "Vyroba_evidence.Vyroba_stav",
         _key_org => get_env("org"),
         _key_zak => $$vazba{zak},
         _key_kmint => $$vazba{kmint},
         _key_str => $$vazba{kmstrvys},
         _add_kszm => $$vazba{kszm},
         datzm => My->date_now,
         datzapis => My->datetime_now,
         uzivzapis => My->remote_user
      });
      # Vyrprikazy - poznamka: mozna bude dobre to predelat na tenhle styl i u Odvadeni (pak to chce upravu prislusne fce, ale i jednotlivych programu)
      if(length($$vazba{prik})) {
         Write->replace({
            _table => "Vyroba_planovani.Vyrprikazy",
            _key_org => get_env("org"),
            _key_zak => $$vazba{zak},
            _key_kmint => $$vazba{kmint},
            _key_prik => $$vazba{prik},
            _add_ksvyk => $$vazba{kszm},
            datvyk => My->date_now,
            datzapis => My->datetime_now,
            uzivzapis => My->remote_user
         });
      }
      ## ZMENA 2003-02-20 - predtim tu nebylo elsif ale else
      # kdyz nejde o manka menim i vyrobni prikaz
      elsif(get_env("progtyp") ne "manka" and get_env("progtyp") ne "specjzm") {
         $pkg->write_vyrprikazy_ksvyk(
            $$vazba{zak},
            $$vazba{kmint},
            $$vazba{kmstrvys},
            $$vazba{kszm}
         );
      }
      # kdyz jde o prebytek, tak navysuji kszad na prikaze o prebytek - na prani Gregra
      elsif(get_env("progtyp") eq "specjzm" and $$vazba{priczm}=~/^04/) {
         $pkg->write_vyrprikazy_kszad(
            $$vazba{zak},
            $$vazba{kmint},
            $$vazba{kmstrvys},
            (-1)*$$vazba{kszm}
         );
      }
   }
}

#- funkce zjistuje zaceneni u JineZmeny (znzm=0 z oper znzm=1 bez oper)
sub vnitr_ceny_jinezmeny {
   my ($pkg_p, $zak,$oper,$znzm)=@_;
   my $info_vnitr_ceny;
   if($znzm eq "0" and $oper ne "000") {
      $info_vnitr_ceny=Info->vnitr_ceny($zak,sprintf("%3.3d",(1*$oper)-1));
   }
   else {
      $info_vnitr_ceny=Info->vnitr_ceny($zak,$oper);
   }
   return $info_vnitr_ceny;
}

#- zapis do Odpracvyk u ZnR=2
sub write_odpracvyk {
   my ($pkg_p, $vazba)=@_;
   my $sth_vazby=$dbh->prepare(q{
      select
          Str.org,
          Odpracvyk_vazby.oc
       from
          Spolecnost.Str
          inner join Vyroba_evidence.Odpracvyk_vazby on (Str.str=Odpracvyk_vazby.str)
       where
          Str.str=? and
          Str.platod<=? and
          Str.platdo>=?
   });
   my $sth_norma=$dbh->prepare(q{
      select
         Vykon_norma.str,
         Vykon_norma.oper,
         Vykon_norma.prac,
         Vykon_norma.tta,
         Vykon_norma.tamin
      from
         Vyroba_priprava.Vykon_norma
      where
         Vykon_norma.org=? and
         Vykon_norma.zak=? and
         Vykon_norma.oper>=? and
         Vykon_norma.oper<=? and
         Vykon_norma.platod<=? and
         Vykon_norma.platdo>=?
   });
   $sth_norma->execute(get_env("org"),$$vazba{zakn},$$vazba{odoper},$$vazba{dooper},get_env("datum"),get_env("datum"));
   while(my $ref_norma=$sth_norma->fetchrow_hashref) {
      ## ZMENA 2002-12-07 - pridan if nize - u organizaci jinych nez 7 musi byt prvni 3 mista strediska odvadeciho totozna s tremi misty strediska na ktery se ma pripadne automaticky odvest odpr. vykon
      if(get_env("org") eq "7" or substr($$ref_norma{str},0,3) eq substr($$vazba{strodv},0,3)) {
         $sth_vazby->execute($$ref_norma{str},get_env("datum"),get_env("datum"));
         my $ref_vazby=$sth_vazby->fetchrow_hashref;
         $sth_vazby->finish;
         ## ZMENA 2003-02-04 - urceni DM s typu kolektivu
         my $dm;
         my $info_oc=Info->oc($$ref_vazby{oc});
         if($$info_oc{typzam}=~/^JD/) {
            $dm="11";
         }
         else {
            $dm="12";
         }
         if($$ref_vazby{org} eq get_env("org")) {
            Write->insert({
               _table => "Vyroba_evidence.Odpracvyk",
               org => get_env("org"),
               ucetobd => substr(get_env("datum"),0,7),
               str => $$ref_norma{str},
               strmzda => $$info_oc{str}, ## ZMENA 2003-02-06 - predtim chybne $$ref_norma{str}
               oc => $$ref_vazby{oc},
               zak => $$vazba{zakn},
               oper => $$ref_norma{oper},
               dm => $dm,
               kmint => $$vazba{kmint},
               prik => $$vazba{prik},
               prac => $$ref_norma{prac},
               pric => "",
               tt => $$ref_norma{tta},
               ksdobr => $$vazba{mnozc},
               zmplac => "0",
               hod => "0",
               nhod => $$vazba{mnozc}*$$ref_norma{tamin}/60,
               nkc => $$vazba{mnozc}*(Info->tkc($$ref_norma{tta},$$ref_norma{tamin})),
               pozn => $$vazba{pozn}
            });
         }
      }
   }
   $sth_norma->finish;
}

#- fce uzivana pro zjisteni, zda se ma zaznamenat prijem a zmena stavu na stredisku, ktere ma zak prijmout (pri odvadeni)
sub maybe_autoprijem {
   my ($pkg_p, $strprij)=@_;
   my $maybe_autoprijem=0;
   my $info_strprij=Info->str($strprij);
   if($$info_strprij{org} eq get_env("org") and grep(/^\Q$$info_strprij{vyrtyp}\E$/, ("dilmech","dilopt","sklhs","dilmon","dilpu","sklrv"))) {
      $maybe_autoprijem=1;
   }
   return $maybe_autoprijem;
}

#- fce uzivana pro zjisteni, zda se ma zaznamenat prijem a zmena stavu na stredisku, ktere ma zak prijmout (pri odvadeni)
sub maybe_autoprijem_sklhv {
   my ($pkg_p, $strprij)=@_;
   my $maybe_autoprijem;
   my $info_strprij=Info->str($strprij);
   if($$info_strprij{org} eq get_env("org") and $$info_strprij{org} eq "6" and $$info_strprij{vyrtyp} eq "sklhv") {
      ## 2003-04-01 - sklhv org 6 prechazi pod spravu org 3 a automatika se rusi  - fce maybe_autoprijem_sklhv vzdy vraci hodnotu 0
      ##$maybe_autoprijem=1;
      $maybe_autoprijem=0;
   }
   else {
      $maybe_autoprijem=0;
   }
   return $maybe_autoprijem;
}

#- urceni kolonky ucet na zaklade Strprij ci jinak
sub ucet_odvadeni {
   my ($pkg_p,$strprij)=@_;
   my $ucet;
   my $info_strprij=Info->str($strprij);
   # podminka nize by mela znamenat "dokud je to v RV" pokud neni splnena jde to ven (ven z RV)
   if($$info_strprij{org} eq get_env("org") and grep(/^\Q$$info_strprij{vyrtyp}\E$/, ("dilmech","dilopt","dilmon","dilpu","sklrv"))) {
      $ucet="121100";
   }
   else {
      $ucet="123100";
   }
   return $ucet;
}

#- nalezeni nasledujiciho (vysiko) kmint nez je zadany
sub kmintv {
   my ($pkg_p,$zak,$kmint)=@_;
   my $kmintv;
   my $sth=$dbh->prepare(q{
      select
         Normativy.kmint
      from
         Vyroba_planovani.Normativy
      where
         Normativy.org=? and
         Normativy.zak=? and
         Normativy.kmint>? and
         Normativy.platod<=? and
         Normativy.platdo>=?
      order by
         Normativy.kmint asc
      limit
         1
   });
   $sth->execute(get_env("org"),$zak,$kmint,get_env("datum"),get_env("datum"));
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   if(length($$ref{kmint})) {
      $kmintv=$$ref{kmint};
   }
   else {
      $kmintv="999";
   }
   return $kmintv;
}

# Automaticky zapis $ksvyk do Vyrobnich prikazu do tech poslednich (jen u $zak,$kmint) - zapisuji az do vynulovani $ksvyk
sub write_vyrprikazy_ksvyk {
   my ($pkg_p, $zak,$kmint,$str,$ksvyk)=@_;
   my $dbh=My->dbh;
   my $sth;
   if($ksvyk>=0) {
      # seznam nesplnenych vyrobnich prikazu
      $sth=$dbh->prepare(q{
         select
            Vyrprikazy.prik,
            Vyrprikazy.kszad-Vyrprikazy.ksvyk as kszapsat
         from
            Vyroba_planovani.Vyrprikazy
         where
            Vyrprikazy.org=? and
            Vyrprikazy.zak=? and
            Vyrprikazy.kmint=? and
            Vyrprikazy.str=? and
            Vyrprikazy.kszad>Vyrprikazy.ksvyk
         order by
            Vyrprikazy.datzac asc,
            Vyrprikazy.prik asc
      });
   }
   else {
      # seznam splnenych ci jiz castecne vykazanych vyrobnich prikazu
      $sth=$dbh->prepare(q{
         select
            Vyrprikazy.prik,
            (-1.0000*Vyrprikazy.ksvyk) as kszapsat
         from
            Vyroba_planovani.Vyrprikazy
         where
            Vyrprikazy.org=? and
            Vyrprikazy.zak=? and
            Vyrprikazy.kmint=? and
            Vyrprikazy.str=? and
            Vyrprikazy.ksvyk>0
         order by
            Vyrprikazy.datzac desc,
            Vyrprikazy.prik desc
      });
   }
   $sth->execute(get_env("org"),$zak,$kmint,$str);
   while(my $ref=$sth->fetchrow_hashref) {
      # kolik budu zapisovat na nalezeny prikaz
      my $kszapsat;
      if(($ksvyk>=0 and $ksvyk>=$$ref{kszapsat}) or ($ksvyk<0 and $ksvyk<$$ref{kszapsat})) {
         $kszapsat=$$ref{kszapsat};
      }
      else {
         $kszapsat=$ksvyk;
      }
      # zapis
      Write->replace({
         _table => "Vyroba_planovani.Vyrprikazy",
         _key_org => get_env("org"),
         _key_zak => $zak,
         _key_kmint => $kmint,
         _key_prik => $$ref{prik},
         _add_ksvyk => $kszapsat,
         datvyk => My->date_now,
         datzapis => My->datetime_now,
         uzivzapis => My->remote_user
      });
      # ponizeni $ksvyk o zapsane kusy a tak ziskani cisla co jeste mam zapsat
      $ksvyk-=$kszapsat;
      if($ksvyk==0) {
         last;
      }
   }
   $sth->finish;
}
# navyseni vyrobniho prikazu o zadany pocet kusu dany prebytkem - pouziva se u JineZmeny v pripade zapisu prebytku
sub write_vyrprikazy_kszad {
   my ($pkg_p, $zak,$kmint,$str,$addkszad)=@_;
   # pro jednoduchost tak cinim jen v pripade, ze $kszad je zaporne (tedy nejde o opravu zapisu prebytku)
   if($addkszad>0) {
      # hledam prvni nesplneny prikaz
      my $sth=$dbh->prepare(q{
         select
            Vyrprikazy.prik,
            Vyrprikazy.kszad-Vyrprikazy.ksvyk as kszapsat
         from
            Vyroba_planovani.Vyrprikazy
         where
            Vyrprikazy.org=? and
            Vyrprikazy.zak=? and
            Vyrprikazy.kmint=? and
            Vyrprikazy.str=? and
            Vyrprikazy.kszad>Vyrprikazy.ksvyk
         order by
            Vyrprikazy.datzac asc,
            Vyrprikazy.prik asc
         limit
            1
      });
      $sth->execute(get_env("org"),$zak,$kmint,$str);
      ## ZMENA 2003-03-04 - dodal jsem if, ktery by mel zajistit, ze k zapisu dojde jen v pripade, ze byl nalezen nejaky prikaz
      if(my $ref=$sth->fetchrow_hashref) {
         # zapis
         Write->replace({
            _table => "Vyroba_planovani.Vyrprikazy",
            _key_org => get_env("org"),
            _key_zak => $zak,
            _key_kmint => $kmint,
            _key_prik => $$ref{prik},
            _add_kszad => $addkszad,
            datvyk => My->date_now,
            datzapis => My->datetime_now,
            uzivzapis => My->remote_user
         });
      }
      $sth->finish;
   }
}
#- kontrola str zda existuje a zda je zadaneho vyrtyp - pokud ne vraci undef
sub check_str_pravo {
   my ($pkg_p, $str)=@_;
   ## ZMENA 2002-07-17 - kontrola je nyni mekci chci, aby funkce urcene puvodne pro jine typy dilen mohli uzit i na jinych dilnach
   ## - tedy rusim kontrolu zda je sladen typstrediska s typem funkce na kterou je urcena
   ## - to zda je fci mozne pouzit resi metodik pri pridelovani prav konkretnimu cloveku na zadany okruh stredisek
   ##my $vyrtyp=get_env("vyrtyp");
   my $str_pravo=My->str;
   ##my $info_str=Info->str($str);
   if(!($$str_pravo{$str})) {
   ##if(!($$str_pravo{$str} and $$info_str{vyrtyp} eq $vyrtyp)) {
      $str=undef;
   }
   return $str;
}

#- kontrola str zda existuje a zda je na nej pravo
sub check_str_pravo_zm {
   my ($pkg_p, $str)=@_;
   my $str_pravo=My->str;
   if(!($$str_pravo{$str})) {
      $str=undef;
   }
   return $str;
}

#- kontrola str zda je vyrtyp takovy, ze na nem mohou byt vyskytovat zmetky a jine zmeny stavu - proste zda je vyrobni
sub check_str_vyrtyp_zm {
   my ($pkg_p, $str)=@_;
   my $info_str=Info->str($str);
   # manka apod. mohou byt i na sklrv a sklhs
   if((get_env("progtyp") eq "manka" or get_env("progtyp") eq "specjzm")) {
      if(!(grep(/^\Q$$info_str{vyrtyp}\E$/, ("dilmech","dilopt","sklhs","dilmon","dilpu","sklrv")))) {
         $str=undef;
      }
   }
   # zmetky vazane na odprac. vykon a zmetky nemohou byt na sklrv nebo sklhs
   elsif(!(grep(/^\Q$$info_str{vyrtyp}\E$/, ("dilmech","dilopt","dilmon","dilpu")))) {
      $str=undef;
   }
   return $str;
}

#- kontrola str zda existuje a zda je vyrtyp na ktery je mozne prijmat - pokud ne vraci undef
sub check_str_pravo_prijem {
   my ($pkg_p, $str)=@_;
   my $str_pravo=My->str;
   my $info_str=Info->str($str);
   if(!($$str_pravo{$str} and grep(/^\Q$$info_str{vyrtyp}\E$/, ("dilmech","dilopt","sklhs","dilmon","dilpu","sklrv")))) {
      $str=undef;
   }
   return $str;
}

return 1;

