package Vyroba_planovani_vydejky;

use strict;

my $pkg="Vyroba_planovani_vydejky";

use My;

#== napojeni na db
my $dbh=My->dbh;


# Zjisteni posledniho cisla vydejky
sub cisvyd_porad {
   my $dbh=My->dbh;
   # Poznamka: podminka na delku 7 je zde protoze nove vydejky maji 7 znaku (puvodni meli 6 a ty nechi aby se mi zde pletli)
   my $sth=$dbh->prepare(q{
      select
         substring(Vydejky.cisvyd,3,5) as cisvyd_porad
      from
         Vyroba_planovani.Vydejky
      where
         Vydejky.org=? and
         Vydejky.cisvyd like ? and
         length(Vydejky.cisvyd)=7 and
         substring(Vydejky.cisvyd,3,5)<70000
      order by
         substring(Vydejky.cisvyd,3,5) desc
      limit
         1
   });
   $sth->execute(get_env("org"), get_env("org") . substr(get_env("datum"),3,1) . "%" );
   my $ref=$sth->fetchrow_hashref;
   my $cisvyd_porad=$$ref{cisvyd_porad};
   $sth->finish;
   # prvni vydejky zacnu cislovat od cisla 1000 - z duvodu, ze na hpux jiz existuji nejake s cislem pro rok 2003 a pri zkracovani by se mohly zacit krizit
   if($cisvyd_porad<1000) {
      $cisvyd_porad="1000";
   }
   return $cisvyd_porad;
}

# 
sub cisvyd {
   my ($pkg_p,$cisvyd_porad)=@_;
   return get_env("org") . substr(get_env("datum"),3,1) . sprintf("%5.5d",$cisvyd_porad);
}

#- funkce vraci mnozstvi materialu v nevydanych vydejkach v zadane mj (zadana mj je vetsinou s ciselniku materialu, tedy mj skladova)
sub nvyd {
   my ($pkg_p, $mat,$mj)=@_;
   # priprava dotazu pro zjistovani informaci ve vydejkach
   my $sth_nvyd=$dbh->prepare(q{
      select
         sum(Mjconv.koef*Vydejky.mnoz*(Vydejky.kspoz-Vydejky.ksvyd)) as nvyd
      from
         Vyroba_planovani.Vydejky
         inner join Zakazky.Mjconv on (Vydejky.mj=Mjconv.mjold and Mjconv.mjnew=?)
      where
         Vydejky.mat=? and
         Vydejky.kspoz>Vydejky.ksvyd
   });
   $sth_nvyd->execute($mj,$mat);
   my $ref_nvyd=$sth_nvyd->fetchrow_hashref;
   $sth_nvyd->finish;
   return $ref_nvyd;
}

return 1;

