package Vyroba_priprava;

my $pkg="Vyroba_priprava";

use strict;
use lib ("/home/web-mycompany/www/lib");
use My;
use Info;

#==== Globalni promena tohohle balicku

#==== Napojeni na DB
my $dbh=My->dbh;


#- funkce vraci nazvoslovi ruznych druhu zobrazeni kusovniku
sub kustypmenu {
   my $kustypmenu=[
      ["nizsi","Ni"],
      ["vyssi","Vy"],
      ["strom","Strom"],
      ["souhrn","Souhrn"],
      ["kde","Kam vstupuje?"],
      #["kde3738","Kam vstupuje (ch: 37,38)?"],
      ["konstr","Konstrukn"]
   ];
   my $kustypmenunazev;
   my $i=0;
   foreach my $kustypmenupol (@$kustypmenu) {
      $$kustypmenunazev{$$kustypmenupol[0]}=$$kustypmenupol[1];
      ++$i;
   }
   return ($kustypmenu,$kustypmenunazev);
}

#- funkce vraci seznam nazvu charakteristik v hashi (dobre at nemusim se neustale obrace na tabulku v MySQL)
sub chseznam {
   my $ch;
   my $sth_ch=$dbh->prepare(q{
      select
         Charakteristiky.ch,
         Charakteristiky.nazev
      from
         Zakazky.Charakteristiky
   });
   $sth_ch->execute;
   while(my $ref_ch=$sth_ch->fetchrow_hashref) {
      $$ch{$$ref_ch{ch}}=$$ref_ch{nazev};
   }
   $sth_ch->finish;
   return $ch;
}

#- funkce vraci seznam moznych kmorg materialu na zaklade Matrady
sub seznam_matkmorg {
   my ($pkg_p, $mat)=@_;
   my @seznam_matkmorg;
   my ($dotaz,@dotazpara);
   $dotaz.=q{
      select
         Matrady.org
      from
         Material.Matrady
      where
         Matrady.rada=?
      order by
         Matrady.rada asc
   };
   push(@dotazpara,(substr($mat,0,2)));
   my $sth=$dbh->prepare($dotaz);
   $sth->execute(@dotazpara);
   while(my $ref=$sth->fetchrow_hashref) {
      push(@seznam_matkmorg,$$ref{org});
   }
   $sth->finish;
   return @seznam_matkmorg;
}

#- funkce vraci seznam moznych kmorg naradi na zaklade Narrady
sub seznam_narkmorg {
   my ($pkg_p, $nar)=@_;
   my @seznam_narkmorg;
   my ($dotaz,@dotazpara);
   $dotaz.=q{
      select
         Narrady.org
      from
         Naradi.Narrady
      where
         Narrady.rada=?
      order by
         Narrady.rada asc
   };
   push(@dotazpara,(substr($nar,0,2)));
   my $sth=$dbh->prepare($dotaz);
   $sth->execute(@dotazpara);
   while(my $ref=$sth->fetchrow_hashref) {
      push(@seznam_narkmorg,$$ref{org});
   }
   $sth->finish;
   return @seznam_narkmorg;
}

#- funkce vraci seznam moznych druhu priloh
sub seznam_prilohy_operace_druhy {
   my $sth=$dbh->prepare(q{
      select
         Prilohy_operace_druhy.druh
      from
         Vyroba_priprava.Prilohy_operace_druhy
      where
         Prilohy_operace_druhy.ind="0"
      order by
         Prilohy_operace_druhy.druh asc
   });
   $sth->execute;
   my @prilohy_operace_druhlist;
   while(my $ref=$sth->fetchrow_hashref) {
      push(@prilohy_operace_druhlist,$$ref{druh});
   }
   $sth->finish;
   return @prilohy_operace_druhlist;
}

#- funkce vraci kmorg k zadane kooperacni zakazce
sub koop_kmorg {
   my ($pkg_p, $zak)=@_;
   my $info_zak_nekoop=Info->zak(substr($zak,0,-1)."0");
   return $$info_zak_nekoop{kmorg};
}

#- funkce vraci kooporg k zadane kooperacni zakazce
sub koop_kooporg {
   my ($pkg_p, $zak)=@_;
   my $info_zak=Info->zak($zak);
   return $$info_zak{kmorg};
}

return 1;

